create PACKAGE BODY "BI_AGGREGATE" is

 PROCEDURE PROC_CALLINFO_DAY (V_PRD_ID IN VARCHAR2,V_HOUR IN NUMBER,TAR_OBJECT OUT VARCHAR2, TOTAL_RECORDS OUT NUMBER) IS

    V_FROM_TABLE_1   VARCHAR2(52);
    V_TO_TABLE    VARCHAR2(52);
    V_SQL_TXT      VARCHAR2(20000);
    V_ERRORCODE    NUMBER;
    V_ERRORTEXT    VARCHAR2(1024);
    PROCEDURE_NAME VARCHAR2(65);
    CURRENT_TIME VARCHAR2(20);
    V_DEL_SQL_TXT VARCHAR2(1024);
    
  BEGIN

    V_FROM_TABLE_1  := 'SP_IPCC_OMAP.CALLINFO';
    V_TO_TABLE    := 'SP_IPCC_OMAP.TF_CALL_SKILL_HR';
    PROCEDURE_NAME := 'BI_AGGREGATE.PROC_CALLINFO_DAY';
    TAR_OBJECT     := '';
    TOTAL_RECORDS :=0;
    CURRENT_TIME := V_PRD_ID||to_char(V_HOUR);
--    CURRENT_TIME_FMT := 'yyyymmddhh24';
    
      
    --INSERT DATA
    BEGIN
    if V_PRD_ID is null or V_PRD_ID = '' then
      select to_char(sysdate,'yyyyMMdd') || '00' into CURRENT_TIME from dual;
    else
      CURRENT_TIME := V_PRD_ID||'00';
    end if;

       ---------------------------------------------------<SETP 1 BEGIN>--------------------------------
--      V_SQL_TXT := 'insert into '||V_TO_TABLE||' PARTITION(PARTNUM_'||substr(V_PRD_ID,3,6)||')'
      V_SQL_TXT := 'insert into '||V_TO_TABLE
--||' (DURATION , '
||' (CALL_DURA , '
||' WAITING_TIME_DURA , '
||' ACD_TIME_DURA , '
||' CALL_TIMES , '
--||' HOUR , '
||' HR , '
||' PRD_ID , '
||' IMPORT_DATE , '
||' CALL_TYPE , '
||' CALLED , '
||' CALLED_TYPE , '
||' JOINED , '
--||' TRANSFER_CALLED , '
||' POLY_TYPE , '
||' IN_REASON , '
--||' AGENT_ID , '
||' SHORT_CODE_TYPE , '
||' MSP_TYPE , '
--||' WAITCALL_DURA_LV , '
||' WAIT_DURA_LV , '
||' CALL_DURA_LV,'
||' date_hour)'
||' select sum(duration) call_dura, '
||' sum(waiting_time) waiting_time_dura,'
||' sum(acd_time) acd_time_dura, '
||' count(*) call_times,'
||' HR , '
||' PRD_ID, '
||' IMPORT_DATE, '
||' CALL_TYPE ,  '
||' CALLED , '
||' CALLED_TYPE , '
||' JOINED , '
||' POLY_TYPE , '
--||' TRANSFER_CALLED ,  '
||' IN_REASON , '
--||' AGENT_ID , '
||' SHORT_CODE_TYPE,'
||' MSP_TYPE,'
--||' waitcall_dura_lv,'
||' wait_dura_lv,'
||' call_dura_lv,'
|| 'date_hour'
||' from '
||' (select '
||' to_char(start_time,''hh24'') hr ,to_char(start_time,''yyyymmdd'') prd_id ,'
||' to_char(sysdate, ''yyyymmdd'') import_date ,'
--||' a.callinfo_id, '
||' a.call_id, '
||' nvl(a.call_type,-1) call_type,'--inbound/outbound
||' a.caller, '
||' a.called,'
||' a.start_time, '
||' a.end_time, '
||' nvl(a.called_type,-1) called_type, ' --IVR/ACD
||' nvl(a.joined,-1) joined,' -- miss/answer
--||' nvl(a.Transfer_called,-1) Transfer_called,' --change ivr/acd
||' nvl(a.poly_type,-1) poly_type,' -- to ivr/acd
||' a.duration,' --thoi gian ca cuoc goi
||' a.waiting_time,'--thoi gian cho
||' a.acd_time, '--thoi gian tra loi
||' nvl(a.in_reason,-1) in_reason,' -- nguyen nhan ket thuc
--||' nvl(a.agent_id,-1) agent_id,'
||' nvl(b.short_code_type,-1) short_code_type,'
||' nvl(b.msp_type,-1) msp_type,'
--||' c.level_id waitcall_dura_lv,'
||' c.level_id wait_dura_lv,'
||' d.level_id call_dura_lv,'
|| 'to_date(to_char(a.start_time,''yyyymmddhh24''), ''yyyymmddhh24'') date_hour'
||' from '||V_FROM_TABLE_1||' a left join short_code b on substr(a.caller,1, length(b.short_code_id)) = b.short_code_id '
||' left join td_call_dura_lv c on  waiting_time > = c.START_VALUE and waiting_time < c.END_VALUE ' 
||' left join td_call_dura_lv d on  duration > = d.START_VALUE and duration < d.END_VALUE '
--||' where start_time >= (TO_DATE('||CURRENT_TIME||', ''yyyymmddhh24'')-1/24)'
||' where start_time >= TO_DATE('||CURRENT_TIME||', ''yyyymmddhh24'')'
--||' and start_time < TO_DATE('||CURRENT_TIME||', ''yyyymmddhh24'')'

||' )'
||' group by'
||' HR , '
||' PRD_ID, '
||' IMPORT_DATE, '
||' CALL_TYPE ,  '
||' CALLED , '
||' CALLED_TYPE , '
||' JOINED , '
||' POLY_TYPE ,  '
||' IN_REASON , '
--||' AGENT_ID , '
||' SHORT_CODE_TYPE,'
||' MSP_TYPE,'
--||' waitcall_dura_lv,'
||' wait_dura_lv,'
||' call_dura_lv,'
||' date_hour';

insert into SP_IPCC_OMAP.test_sql(sql_text) values (V_SQL_TXT);   

      V_DEL_SQL_TXT := 'delete from ' ||V_TO_TABLE|| ' where import_date >=' ||substr(CURRENT_TIME,1,8);
      -- xoa du lieu truoc khi tong hop
      EXECUTE IMMEDIATE V_DEL_SQL_TXT;
commit;  
      EXECUTE IMMEDIATE V_SQL_TXT;
      TOTAL_RECORDS := TOTAL_RECORDS + SQL%ROWCOUNT;
      TAR_OBJECT := TAR_OBJECT||' + '||V_TO_TABLE;
      COMMIT;

      ---------------------------------------------------<SETP 1 END>--------------------------------

    EXCEPTION
      WHEN OTHERS THEN
        V_ERRORCODE   := SQLCODE;
        V_ERRORTEXT   := SUBSTR(SQLERRM, 1, 512);
        TOTAL_RECORDS := 0;

        ROLLBACK;
        RAISE_APPLICATION_ERROR(-20001,
                                'EXEC PROCEDURE ' || PROCEDURE_NAME ||
                                ' INSERT  ' || V_TO_TABLE ||
                                '  DATA ERROR:' || V_ERRORCODE || ' : ' ||
                                V_ERRORTEXT);

    END;

  END PROC_CALLINFO_DAY;
  
  
   PROCEDURE PROC_WOKGROUP_DAY (V_PRD_ID IN VARCHAR2,V_HOUR IN NUMBER,TAR_OBJECT OUT VARCHAR2, TOTAL_RECORDS OUT NUMBER) IS

    V_FROM_TABLE_1   VARCHAR2(52);
    V_TO_TABLE    VARCHAR2(52);
    V_SQL_TXT      VARCHAR2(20000);
    V_ERRORCODE    NUMBER;
    V_ERRORTEXT    VARCHAR2(1024);
    PROCEDURE_NAME VARCHAR2(65);
    CURRENT_TIME VARCHAR2(20);
    V_DEL_SQL_TXT VARCHAR2(1024);

  BEGIN

    V_FROM_TABLE_1  := 'SP_IPCC_OMAP.DTMF_LOG';
    V_TO_TABLE    := 'SP_IPCC_OMAP.TF_CALL_WORKGROUP_HR';
    PROCEDURE_NAME := 'BI_AGGREGATE.PROC_WOKGROUP_DAY';
    TAR_OBJECT     := '';
    TOTAL_RECORDS :=0;
    CURRENT_TIME := V_PRD_ID||to_char(V_HOUR);
   

    --INSERT DATA
    BEGIN
    if V_PRD_ID is null or V_PRD_ID = '' then
      select to_char(sysdate,'yyyyMMdd') || '00' into CURRENT_TIME from dual;
    else
      CURRENT_TIME := V_PRD_ID||'00';
    end if;

       ---------------------------------------------------<SETP 1 BEGIN>--------------------------------
--      V_SQL_TXT := 'insert into '||V_TO_TABLE||' PARTITION(PARTNUM_'||substr(V_PRD_ID,3,6)||')
      V_SQL_TXT := 'insert into '||V_TO_TABLE||' 
      
  (CALL_TIMES , 
  HR , 
  PRD_ID , 
  IMPORT_DATE , 
  WORKGROUP_NAME , 
  DTMF,
  CALLED,
  date_hour)
select count(*) call_times , 
hr, prd_id, import_date ,ivr_name, dtmf, called,date_hour
from 
(select to_char(start_time,''hh24'') hr,to_char(start_time,''yyyymmdd'') prd_id ,to_char(sysdate, ''yyyymmdd'') import_date ,
nvl(ivr_name,-1) ivr_name, duration, call_id, a.dtmf, called,to_date(to_char(start_time,''yyyymmddhh24''), ''yyyymmddhh24'') date_hour
from '||V_FROM_TABLE_1||' a, ivr_tree b 
where a.dtmf = b.dtmf(+)
and start_time >= TO_DATE('||CURRENT_TIME||', ''yyyymmddhh24'')
)
group by hr,  prd_id, import_date , ivr_name, dtmf, called, date_hour';
insert into SP_IPCC_OMAP.test_sql(sql_text) values (V_SQL_TXT);   
       V_DEL_SQL_TXT := 'delete from ' ||V_TO_TABLE|| ' where import_date >=' ||substr(CURRENT_TIME,1,8);
      -- xoa du lieu truoc khi tong hop
      EXECUTE IMMEDIATE V_DEL_SQL_TXT;
commit;  
      EXECUTE IMMEDIATE V_SQL_TXT;
      TOTAL_RECORDS := TOTAL_RECORDS + SQL%ROWCOUNT;
      TAR_OBJECT := TAR_OBJECT||' + '||V_TO_TABLE;
      COMMIT;

      ---------------------------------------------------<SETP 1 END>--------------------------------

    EXCEPTION
      WHEN OTHERS THEN
        V_ERRORCODE   := SQLCODE;
        V_ERRORTEXT   := SUBSTR(SQLERRM, 1, 512);
        TOTAL_RECORDS := 0;

        ROLLBACK;
        RAISE_APPLICATION_ERROR(-20001,
                                'EXEC PROCEDURE ' || PROCEDURE_NAME ||
                                ' INSERT  ' || V_TO_TABLE ||
                                '  DATA ERROR:' || V_ERRORCODE || ' : ' ||
                                V_ERRORTEXT);

    END;

  END PROC_WOKGROUP_DAY;
  
  
   PROCEDURE PROC_CALL_SERVICE_DAY (V_PRD_ID IN VARCHAR2,V_HOUR IN NUMBER,TAR_OBJECT OUT VARCHAR2, TOTAL_RECORDS OUT NUMBER) IS

    V_FROM_TABLE_1   VARCHAR2(52);
    V_TO_TABLE    VARCHAR2(52);
    V_SQL_TXT      VARCHAR2(20000);
    V_ERRORCODE    NUMBER;
    V_ERRORTEXT    VARCHAR2(1024);
    PROCEDURE_NAME VARCHAR2(65);
    CURRENT_TIME VARCHAR2(20);
    V_DEL_SQL_TXT VARCHAR2(1024);

  BEGIN

    V_FROM_TABLE_1  := 'SP_IPCC_OMAP.CALL';
    V_TO_TABLE    := 'SP_IPCC_OMAP.TF_CALL_SERVICE_HR';
    PROCEDURE_NAME := 'BI_AGGREGATE.PROC_CALL_SERVICE_DAY';
    TAR_OBJECT     := '';
    TOTAL_RECORDS :=0;
    CURRENT_TIME := V_PRD_ID||to_char(V_HOUR);
   

    --INSERT DATA
    BEGIN
    if V_PRD_ID is null or V_PRD_ID = '' then
      select to_char(sysdate,'yyyyMMdd') || '00' into CURRENT_TIME from dual;
    else
      CURRENT_TIME := V_PRD_ID||'00';
    end if;

       ---------------------------------------------------<SETP 1 BEGIN>--------------------------------
--      V_SQL_TXT := 'insert into '||V_TO_TABLE||' PARTITION(PARTNUM_'||substr(V_PRD_ID,3,6)||')
      V_SQL_TXT := 'insert into '||V_TO_TABLE||' 
      
  (CALL_TIMES , 
  HR, 
  PRD_ID , 
  IMPORT_DATE , 
  CALLED , 
  SERVICE_ID,
  INS_ANS_DURA,
  ins_ans_avg, 
  INS_ANS_DURA_LV,
  CALL_DURA,
  call_dura_avg,
  CALL_DURA_LV,
  date_hour)
select count(*) call_times , 
hr, prd_id, import_date , called, service_id,sum(answer_time) ins_ans_dura,round(avg(answer_time),3) ins_ans_avg, INS_ANS_DURA_LV,
sum(duration) call_dura,round(avg(duration),3) call_dura_avg ,CALL_DURA_LV, date_hour
from 
(select to_char(start_time,''hh24'') hr,to_char(start_time,''yyyymmdd'') prd_id ,to_char(sysdate, ''yyyymmdd'') import_date ,
nvl(service_group,-1) service_id, duration, answer_time,called,c.level_id INS_ANS_DURA_LV, d.level_id CALL_DURA_LV,
to_date(to_char(start_time,''yyyymmddhh24''), ''yyyymmddhh24'') date_hour
from '||V_FROM_TABLE_1||' a 
left join td_call_dura_lv c on  answer_time > = c.START_VALUE and answer_time < c.END_VALUE 
left join td_call_dura_lv d on  duration > = d.START_VALUE and duration < d.END_VALUE 
where start_time >= TO_DATE('||CURRENT_TIME||', ''yyyymmddhh24'')
)
group by hr,  prd_id, import_date , called, service_id, call_dura_lv,ins_ans_dura_lv,date_hour';
insert into SP_IPCC_OMAP.test_sql(sql_text) values (V_SQL_TXT);   

        V_DEL_SQL_TXT := 'delete from ' ||V_TO_TABLE|| ' where import_date >=' ||substr(CURRENT_TIME,1,8);
      -- xoa du lieu truoc khi tong hop
      EXECUTE IMMEDIATE V_DEL_SQL_TXT;
commit;     
      EXECUTE IMMEDIATE V_SQL_TXT;
      TOTAL_RECORDS := TOTAL_RECORDS + SQL%ROWCOUNT;
      TAR_OBJECT := TAR_OBJECT||' + '||V_TO_TABLE;
      COMMIT;

      ---------------------------------------------------<SETP 1 END>--------------------------------

    EXCEPTION
      WHEN OTHERS THEN
        V_ERRORCODE   := SQLCODE;
        V_ERRORTEXT   := SUBSTR(SQLERRM, 1, 512);
        TOTAL_RECORDS := 0;

        ROLLBACK;
        RAISE_APPLICATION_ERROR(-20001,
                                'EXEC PROCEDURE ' || PROCEDURE_NAME ||
                                ' INSERT  ' || V_TO_TABLE ||
                                '  DATA ERROR:' || V_ERRORCODE || ' : ' ||
                                V_ERRORTEXT);

    END;

  END PROC_CALL_SERVICE_DAY;
  
     PROCEDURE PROC_AGENT_DAY (V_PRD_ID IN VARCHAR2,V_HOUR IN NUMBER,TAR_OBJECT OUT VARCHAR2, TOTAL_RECORDS OUT NUMBER) IS

    V_FROM_TABLE_1   VARCHAR2(52);
    V_TO_TABLE    VARCHAR2(52);
    V_SQL_TXT      VARCHAR2(20000);
    V_ERRORCODE    NUMBER;
    V_ERRORTEXT    VARCHAR2(1024);
    PROCEDURE_NAME VARCHAR2(65);
    CURRENT_TIME VARCHAR2(20);
    V_DEL_SQL_TXT VARCHAR2(1024);
  BEGIN

    V_FROM_TABLE_1  := 'SP_IPCC_OMAP.AGENT';
    V_TO_TABLE    := 'SP_IPCC_OMAP.TF_AGENT_MODE_HR';
    PROCEDURE_NAME := 'BI_AGGREGATE.PROC_AGENT_DAY';
    TAR_OBJECT     := '';
    TOTAL_RECORDS :=0;
    CURRENT_TIME := V_PRD_ID||to_char(V_HOUR);
    


    --INSERT DATA
    BEGIN

   if V_PRD_ID is null or V_PRD_ID = '' then
      select to_char(sysdate,'yyyyMMdd') || '00' into CURRENT_TIME from dual;
    else
      CURRENT_TIME := V_PRD_ID||'00';
    end if;
       ---------------------------------------------------<SETP 1 BEGIN>--------------------------------
--   V_SQL_TXT := 'insert into '||V_TO_TABLE||' PARTITION(PARTNUM_'||substr(V_PRD_ID,3,6)||')
   V_SQL_TXT := 'insert into '||V_TO_TABLE||' 
   (CHMOD_TIMES , 
  MOD_DURA , 
  mod_dura_avg,
  HR , 
  STATUS , 
  PRD_ID , 
  IMPORT_DATE , 
  AGENT_ID , 
  AGENT_TYPE ,
  DEVICE_ID,
  date_hour)
select count(*) chmod_times, sum(duration) mod_dura,round(avg(duration),3) mod_dura_avg,
to_char(start_time,''hh24'') hr,status,
to_char(start_time,''yyyymmdd'') prd_id , to_char(sysdate, ''yyyymmdd'') import_date , 
nvl(agent_id,-1) agent_id, nvl(agent_type,-1) agent_type , nvl(device_id,-1) device_id,to_date(to_char(start_time,''yyyymmddhh24''), ''yyyymmddhh24'')  as date_hour
from '||V_FROM_TABLE_1
||' where start_time >= TO_DATE('|| CURRENT_TIME||', ''yyyymmddhh24'')

group by to_char(start_time,''yyyymmdd''), to_char(sysdate, ''yyyymmdd''),
to_char(start_time,''hh24''),
nvl(agent_id,-1) , nvl(agent_type,-1),status, nvl(device_id,-1),to_date(to_char(start_time,''yyyymmddhh24''), ''yyyymmddhh24'') ';
insert into SP_IPCC_OMAP.test_sql(sql_text) values (V_SQL_TXT);   

        V_DEL_SQL_TXT := 'delete from ' ||V_TO_TABLE|| ' where import_date >=' ||substr(CURRENT_TIME,1,8);
      -- xoa du lieu truoc khi tong hop
      EXECUTE IMMEDIATE V_DEL_SQL_TXT;
 commit;  
      EXECUTE IMMEDIATE V_SQL_TXT;
      TOTAL_RECORDS := TOTAL_RECORDS + SQL%ROWCOUNT;
      TAR_OBJECT := TAR_OBJECT||' + '||V_TO_TABLE;
      COMMIT;

      ---------------------------------------------------<SETP 1 END>--------------------------------

    EXCEPTION
      WHEN OTHERS THEN
        V_ERRORCODE   := SQLCODE;
        V_ERRORTEXT   := SUBSTR(SQLERRM, 1, 512);
        TOTAL_RECORDS := 0;

        ROLLBACK;
        RAISE_APPLICATION_ERROR(-20001,
                                'EXEC PROCEDURE ' || PROCEDURE_NAME ||
                                ' INSERT  ' || V_TO_TABLE ||
                                '  DATA ERROR:' || V_ERRORCODE || ' : ' ||
                                V_ERRORTEXT);

    END;

  END PROC_AGENT_DAY;
  
  
   PROCEDURE PROC_CALL_DAY (V_PRD_ID IN VARCHAR2,V_HOUR IN NUMBER,TAR_OBJECT OUT VARCHAR2, TOTAL_RECORDS OUT NUMBER) IS

    V_FROM_TABLE_1   VARCHAR2(52);
    V_TO_TABLE    VARCHAR2(52);
    V_SQL_TXT      VARCHAR2(20000);
    V_ERRORCODE    NUMBER;
    V_ERRORTEXT    VARCHAR2(1024);
    PROCEDURE_NAME VARCHAR2(65);
    CURRENT_TIME VARCHAR2(20);
    LAST_TIME VARCHAR2(20);
    tmp number;
    V_DEL_SQL_TXT VARCHAR2(1024);
  BEGIN

    V_FROM_TABLE_1  := 'SP_IPCC_OMAP.CALL';
    V_TO_TABLE    := 'SP_IPCC_OMAP.TF_AGENT_CALL_HR';
    PROCEDURE_NAME := 'BI_AGGREGATE.PROC_CALL_DAY';
    TAR_OBJECT     := '';
    TOTAL_RECORDS :=0;
    CURRENT_TIME := V_PRD_ID||to_char(V_HOUR);
    
    --INSERT DATA
    BEGIN
     if V_PRD_ID is null or V_PRD_ID = '' then
      select to_char(sysdate,'yyyyMMdd') || '00' into CURRENT_TIME from dual;
    else
      CURRENT_TIME := V_PRD_ID||'00';
    end if;

       ---------------------------------------------------<SETP 1 BEGIN>--------------------------------
--   V_SQL_TXT := 'insert into '||V_TO_TABLE||' PARTITION(PARTNUM_'||substr(V_PRD_ID,3,6)||')
   V_SQL_TXT := 'insert into '||V_TO_TABLE||' 
  (AGENT_ID , 
  DEVICE_ID,
  CALLED,
  HR , 
  PRD_ID , 
  IMPORT_DATE , 
  CALL_TIMES, 
  ANSWER_TIME_DURA , 
  answer_time_avg,
  HOLD_TIME_DURA, 
  hold_time_avg,
  agent_wait_time_avg,
  HOLD_DURA_LV, 
	ANSWER_DURA_LV,
  date_hour)
select agent_id,device_id,called, to_char(start_time,''hh24'') hr,to_char(start_time,''yyyymmdd'') prd_id ,
to_char(sysdate, ''yyyymmdd'') import_date, count(*) call_times, sum(ANSWER_TIME) ANSWER_TIME_DURA,round(avg(ANSWER_TIME),3) answer_time_avg,
sum(HOLD_TIME) HOLD_TIME_DURA, round(avg(HOLD_TIME),3) hold_time_avg,round(avg(agent_waiting_time),3) agent_wait_time_avg,
b.level_id hold_dura_lv,
c.level_id answer_dura_lv,
to_date(to_char(start_time,''yyyymmddhh24''), ''yyyymmddhh24'')  as date_hour

from '||V_FROM_TABLE_1||' a, td_call_dura_lv b, td_call_dura_lv c
where  ANSWER_TIME > = c.START_VALUE(+)
and ANSWER_TIME < c.END_VALUE(+) 
and HOLD_TIME > = b.START_VALUE(+)
and HOLD_TIME < b.END_VALUE(+)
and a.start_time >= TO_DATE('||CURRENT_TIME||', ''yyyymmddhh24'')
GROUP BY agent_id,device_id,called,to_char(start_time,''yyyymmdd'')  , 
to_char(sysdate, ''yyyymmdd''),to_char(start_time,''hh24'') ,c.level_id, b.level_id,to_date(to_char(start_time,''yyyymmddhh24''), ''yyyymmddhh24'') ';
insert into SP_IPCC_OMAP.test_sql(sql_text) values (V_SQL_TXT);   
      V_DEL_SQL_TXT := 'delete from ' ||V_TO_TABLE|| ' where import_date >=' ||substr(CURRENT_TIME,1,8);
      -- xoa du lieu truoc khi tong hop
      EXECUTE IMMEDIATE V_DEL_SQL_TXT;
commit;  
      EXECUTE IMMEDIATE V_SQL_TXT;
      TOTAL_RECORDS := TOTAL_RECORDS + SQL%ROWCOUNT;
      TAR_OBJECT := TAR_OBJECT||' + '||V_TO_TABLE;
      COMMIT;

      ---------------------------------------------------<SETP 1 END>--------------------------------

    EXCEPTION
      WHEN OTHERS THEN
        V_ERRORCODE   := SQLCODE;
        V_ERRORTEXT   := SUBSTR(SQLERRM, 1, 512);
        TOTAL_RECORDS := 0;

        ROLLBACK;
        RAISE_APPLICATION_ERROR(-20001,
                                'EXEC PROCEDURE ' || PROCEDURE_NAME ||
                                ' INSERT  ' || V_TO_TABLE ||
                                '  DATA ERROR:' || V_ERRORCODE || ' : ' ||
                                V_ERRORTEXT);

    END;

  END PROC_CALL_DAY;
  
  PROCEDURE Proc_Create_Partition_For_All(Prd_Id Number) Is

  /*************************************************
  * Description: Table partition manager           *
  * Prd_Id:  Contorl the data that is need add     *
  *           partition and drop partition         *
  * vTableName:  The table name that is managed    *
  * Remark: Need process in 1 of each month       *
  **************************************************/
  vTableName  varchar2(32);
  vUserName   varchar2(32);
  i           Number(10);
  vPart_Name  Varchar2(20);
  vPart_Value Number(10);
  vEnd_Date   Varchar2(10); --Next month(yymm)
  vNext_Date  Varchar2(10); --Next month(yyyymm)
  v_Sql_Txt   Varchar2(2048);
  vMaxday     Number;
  v_result    varchar2(1024);
  vmonth_name number;

  CURSOR cur_daily IS
    select user_name, table_name
      from BI_PARTITION_TABLE a
     where a.flag_no in (1) and (user_name,table_name) in (
    select /*+ parallel(a,10) */ table_owner,table_name from dba_tab_partitions a);


Begin


  vMaxday     := substr(to_char(last_day(add_months(to_date(Prd_Id,'YYMMDD'),1)),'yyyymmdd'),7,2);
--  vEnd_Date   := TO_CHAR(ADD_MONTHS(TO_DATE(PRD_ID, 'YYYYMMDD'), 1), 'YYMM');
--  vNext_Date  := TO_CHAR(ADD_MONTHS(TO_DATE(PRD_ID, 'YYYYMMDD'), 1),'YYYYMM');
--  vmonth_name := TO_CHAR(ADD_MONTHS(TO_DATE(PRD_ID, 'YYYYMMDD'), 1), 'MM');
--  i := Null;
--  ----------------------------Add Partition For Daily Table --------------------------
--
--  OPEN cur_daily;
--  LOOP
--    vTableName := NULL;
--    vUserName  := NULL;
--    FETCH cur_daily
--      INTO vUserName, vTableName;
--    EXIT WHEN cur_daily%NOTFOUND;
--    BEGIN
--
--      Begin
--        For i In 1 .. vMaxday Loop
--          Begin
--            If i < 10 Then
--              Begin
--                vPart_Name := 'PARTNUM_' || vEnd_Date || '0' || i;
--              End;
--            else
--              Begin
--                vPart_Name := 'PARTNUM_' || vEnd_Date || i;
--              End;
--            end if;
--
--            If (i + 1) < 10 Then
--              Begin
--                vPart_Value := vNext_Date || '0' || (i + 1);
--              End;
--            else
--              Begin
--                vPart_Value := vNext_Date || (i + 1);
--              End;
--            end if;
--
--            Begin
--                v_Sql_Txt := '  ALTER TABLE ' || vUserName || '.' ||
--                             vTableName || '    ADD PARTITION ' ||
--                             vPart_Name || ' VALUES LESS THAN( ' ||
--                             vPart_Value || ') TABLESPACE IPCC_CCMS';
--              
--            End;
--            Execute Immediate v_Sql_Txt;
--          EXCEPTION
--            When Others Then
--              v_result := Sqlcode;
--              if (v_result = '-14013' or v_result = '-14074') then
--                null; --PARTITION Already Exists
--              else
--                v_result := substr(SQLERRM(SQLCODE), 0, 511);
--                RAISE_APPLICATION_ERROR(-20001,
--                                        'Create PARTITION Error,Table name[' ||
--                                        vTableName || ']' ||
--                                        ', Partition name [' || vPart_Name ||
--                                        '], Partition values [' ||
--                                        vPart_Value || '],Reason:' ||
--                                        v_result);
--              end if;
--          End;
--        End Loop;
--      End;
--    end;
--  END LOOP;
--  CLOSE cur_daily;

End Proc_Create_Partition_For_All;

end BI_AGGREGATE;
/

