create PACKAGE ipcc_report is

  PROCEDURE "ASSERTTRUE" (rs out number,val IN VARCHAR2,
                                             u_id  IN NUMBER, u_name IN VARCHAR2, vtype in number);
  PROCEDURE "DEL_DATA" (tbl_name IN VARCHAR2,
                                             DAY_NUM  IN NUMBER);
  PROCEDURE "DEL_DATA_CHAT" (tbl_name IN VARCHAR2,
                                             DAY_NUM  IN NUMBER);
  PROCEDURE "EXECUTESQL"
   ( STRING IN varchar2);
     PROCEDURE "GETEMPS" ( p_cursor out rs_types.ins_refcur);
    PROCEDURE "GETGROUP" (
  -- lay de qui danh sach nhom con
  -- chu y can dat job chay thu tuc synVSALoc de dong bo table location tu vsa
  -- so di de dong bo vi loi: ORA-02016: cannot use a subquery in a START WITH on a remote database
   rs in out rs_types.rs_cursor,
 userId NUMBER,
 parentId NUMBER,
 groupList VARCHAR2
);
  PROCEDURE "INSERT_LOG" (P_LOG_INFO VARCHAR2,
                                       P_LOG_DESC VARCHAR,
                                       P_LOG_DATE DATE,
                                       P_LOG_SQL  VARCHAR2);

 PROCEDURE "PARTITION_ADD_ALL" (LENGTH IN NUMBER) ;
 PROCEDURE "PARTITION_CHAT_MESSAGE" (TABLE_NAME IN VARCHAR, PREFIX IN VARCHAR, LENGTH IN NUMBER);
 PROCEDURE "PARTITION_CREATE_TABLE" (TABLE_NAME IN VARCHAR, PREFIX IN VARCHAR, LENGTH IN NUMBER);

 PROCEDURE "PARTITION_DEL_FULLSCAN" (DAY_NUM  IN NUMBER);

    PROCEDURE "PROC_DOSEARCH2_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  pagentid in varchar2,
  pcaller in varchar2,
  pminduration in number,
  pmaxduration in number,
  prn in number,
  prownum in number
);
 PROCEDURE "PROC_GETAGENTCHATLOG" (
-- thong ke chat
  rs in out rs_types.rs_cursor,
  fromDate in NUMBER,
  toDate in NUMBER,
  listSender in VARCHAR2,
  listReceiver in VARCHAR2,
  pmax in number
);
PROCEDURE "PROC_GETAVGWAITINGTIME" (
-- thong ke thoi gian cho trung binh
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pjoined in number,
  pmax in number
);
  PROCEDURE "PROC_GETBLACKLISTLOG" (
 --thong ke lich su chan mo thue bao
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pmax in number
);

 PROCEDURE "PROC_GETBLACKLISTTOSENDTOBCCS" (
  rs in out rs_types.rs_cursor
);
 PROCEDURE "PROC_GETCALLBYFIRSTNUMBER" (
 --THONG KE THEO DAU SO KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pcallType in number,
  ptype in number,
  listShortCode in VARCHAR2,
  pwaitTime in number,
  pduration in number,
  pmax in number
);
  PROCEDURE "PROC_GETCALLBYHH" (
 -- thong ke theo thoi gian nghe (kenh IVR)
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pwaitTime in number,
  pmax in number
);
  PROCEDURE "PROC_GETCALLBYMM" (
 -- thong ke cuoc goi theo phut (kenh IVR)
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pwaitTime in number,
  pmax in number
);
 PROCEDURE "PROC_GETCALLERDETAIL" (
 --THONG KE CHI TIET KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pwaitTime in number,
  pduration in number,
  pmax in number
);
  PROCEDURE "PROC_GETCOLLECTCALLACD_OMAP2"
  (
    rs OUT rs_types.rs_cursor,
    slttransfertype  IN NUMBER,
    fromdate      IN DATE,
    todate        IN DATE,
    listline      IN VARCHAR2,
    listline1     IN VARCHAR2,
    sltreporttype IN NUMBER,
    chkgroupby    IN NUMBER,
    timetype      IN NUMBER,
    groupname     IN VARCHAR2,
    agentuname    IN VARCHAR2,
    pcallid       IN VARCHAR2,
    numbercaller  IN VARCHAR2,
    pdeviceid     IN VARCHAR2,
    pmax          IN NUMBER);

  PROCEDURE "PROC_GETCONFCALLDETAIL" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  in_callid in VARCHAR2,
  in_confid in VARCHAR2,
  pmax in number
);

/*
-- vannt18 comment
  PROCEDURE "PROC_GETCONFREPORT" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  expert in VARCHAR2,
  expertid in VARCHAR2,
  agentid in VARCHAR2,
  deviceid in VARCHAR2,
  mc in VARCHAR2,
  mcid in VARCHAR2,
  in_caller in VARCHAR2,
  listConfId in VARCHAR2,
  in_callid in VARCHAR2,
  ptimetype in number,
  reporttype in NUMBER,
  reportid in VARCHAR2,
  pmax in number
);

*/
 PROCEDURE "PROC_GETDTMFSTATISTIC" (
 -- THONG KE TONG HOP PHIM BAM
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  pcaller in VARCHAR2,
  pdtmf in VARCHAR2,
  pcontent in VARCHAR2,
  pwaitTime in number,
  pmax in number
);
  PROCEDURE "PROC_GETIVRBYTIMES" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listline in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  fromN in number,
  toN in number,
  pmax in number
);
 PROCEDURE "PROC_GETIVRDETAIL" (
 -- THONG KE CHI TIET CUOC GOI KENH IVR
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcustLevel in number,
  pcaller in number,
  pmax in number
);

PROCEDURE "PROC_GETLISTAGENT_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in TIMESTAMP,
  toDate in TIMESTAMP,
  pagentid in varchar2,
  pminduration in number,
  prownum in number
);
 PROCEDURE "PROC_GETLISTCALLBYCALLER_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in TIMESTAMP,
  toDate in TIMESTAMP,
  pcaller in varchar2,
  pagentid in varchar2,
  pminduration in number
);

  PROCEDURE "PROC_GETLOCKEDCALLER" (
 -- thong ke khach hang bi chan van goi len he thong
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  ptotalCall in number,
  pmax in number
);

 PROCEDURE "PROC_GETMISSNOTMISSLINESUM" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pdur1 in number,
  pdur2 in number,
  pdur3 in number,
  pmax in number
);
/*
-- vannt18 comment
PROCEDURE "PROC_GETSIZETABLESPACE";
*/
PROCEDURE "PROC_GETSYSTEMTOTALCALL" (
-- thong ke tong thong tin he thong
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcallType in number,
  preportType in number,
  pmax in number
);
  PROCEDURE "PROC_GETWAITINGTIME" (
 -- thong ke thoi gian cho va gap trung binh
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pmax in number
);

PROCEDURE "PROC_SCAN_TO_CALL_OUT" (numout out number,num in number) ;
  PROCEDURE "PROC_SCAN_TO_LOCK" (num out number) ;

  PROCEDURE "PROC_SCAN_TO_OPEN" (num out number);
   PROCEDURE "PROC_STATUSTICCALRATE" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date
  );

  PROCEDURE "PROC_UBLACKLIST_AFTERSENT" (in_caller in VARCHAR2,in_called in VARCHAR2);
  PROCEDURE "PROC_UBLACKLIST_ISREQUNLOCK" (in_caller in VARCHAR2,in_called in VARCHAR2,userName in VARCHAR2, inlaskUnLockTime in DATE) ;
  PROCEDURE "PROC_UBLACKLIST_SENTSMS" (in_caller in VARCHAR2, in_called in VARCHAR2);
  /*
  -- vannt18 comment
  PROCEDURE "SYNVSALOC" (num out number, LEN IN NUMBER);
  PROCEDURE "SYNVSAGROUP" (num out number, LEN IN NUMBER);
  PROCEDURE "SYNVSAUSER" (num out number, LEN IN NUMBER);
*/
 PROCEDURE "TESTPROC_GETACTIONOFAGENT" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listGroupId in VARCHAR2,
  agentName in VARCHAR2,
  listLine in VARCHAR2,
  listAction in VARCHAR2,
  ptype in number,
  pcallid in VARCHAR2,
  pcaller in VARCHAR2,
  poriAddr in VARCHAR2,
  pmidAgent in VARCHAR2,
  pmax in number
);
  PROCEDURE "TESTPROC_GETAGENTJOBSTATUS" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in DATE,
  toDate in DATE,
  agentIdIn in VARCHAR2,
  pstatus in NUMBER,
  poptionType in NUMBER,
  pdur1 in NUMBER,
  pdur2 in NUMBER,
  pdur3 in NUMBER,
  pdur4 in NUMBER,
  listGroupId in VARCHAR2,
  listLine in VARCHAR2,
  pmax in NUMBER
);
PROCEDURE "TESTPROC_GETAGENTSTATUSDUR" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in DATE,
  toDate in DATE,
  agentIdIn in VARCHAR2,
  pstatus in NUMBER,
  listGroupId in VARCHAR2,
  pmax in NUMBER
);
PROCEDURE "TESTPROC_GETANSWERCALLDETAILS" (
 -- thong ke so cuoc tra loi cua Agent
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  TODATE in date,
  PAGENTID in VARCHAR2,
  limitTime in number,
  pcaller in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in NUMBER,
  pcallid in VARCHAR2,
  PDEVICEID in varchar2,
  listGroupId in VARCHAR2,
  pmax in NUMBER

);

PROCEDURE "TESTPROC_GETDETAILCALLAGENT"
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDate in Date,             -- thoi gian bat dau thong ke --> 2
  TODATE in date,               -- thoi gian ket thuc thong ke --> 3
  AGENTID in varchar2,             -- id nguoi nhan cuoc goi --> 4
  LISTLINE in varchar2,
  LIMITTIME in number,
  listGROUPID in varchar2,
  PCALLTYPE in number,
  PMAX in number                -- so luong ban ghi toi da duoc export --> 14
);


  PROCEDURE "TESTPROC_GETSTATUSCHANGE" (
-- THONG KE SO LAN THAY DOI TRANG THAI
  RS in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  pAgentId in VARCHAR2,
  pstatus in number,
  pduration in number,
  PCOUNT in number,
  listGroupId in VARCHAR2,
  pmax in number
);
  PROCEDURE "TESTPROC_GETSUBCALLEDTHANN" -- vos_vietnb
-- thong ke cuoc goi lon hon n lan
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  listGroupId in VARCHAR2,      -- danh sach kenh --> 4
  listCalledIn in VARCHAR2,       -- danh sach kenh --> 5
  callerIn in VARCHAR2,           -- so dien thoai --> 6
  customerLevelIn in VARCHAR2,    -- loai khach hang --> 7
  ptypeIn in number,              -- loai bao cao --> 8
  ptotalCallIn in number,         -- tong so cuoc goi --> 9
  pjoinedIn in VARCHAR2,          -- dieu kien --> 10
  callIdIn in VARCHAR2,           -- ma cuoc goi --> 11
  agentIdIn in VARCHAR2,            -- ma nhan vien --> 12
  acdTimeIn in VARCHAR2,          -- thoi gian dam thoai --> 13
  waitingTimeIn in VARCHAR2,      -- thoi gian cho --> 14
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 15
);
  PROCEDURE "TESTPROC_GETVIP" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in VARCHAR2,
  toDate in VARCHAR2,
  VIPID in VARCHAR2,
  RANKID in NUMBER,
  pstatus in number,
  pmax in number)
;
  PROCEDURE "TESTPROC_GET_CALL_PER_AGENT" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  LISTLINE in varchar2,
  PCALLTYPE in number,
  customerLevelIn in number,
  PAGENTID in varchar2,
  LIMITTIME in number,
  listGroupId in VARCHAR2,
  POPERATOR in VARCHAR2,
  PMAX in number
);
 PROCEDURE "TEST_AGENT_SCHEDULE" (
  -- Tim kiem lich trung
  rs in out rs_types.rs_cursor,
  agentUsername in VARCHAR2,
  fromDate in Date,
  toDate in Date,
  pmax in number
);

 PROCEDURE "TEST_GETAGENTCHATLOG" (
-- thong ke chat
  rs in out rs_types.rs_cursor,
  fromDate in NUMBER,
  toDate in NUMBER,
  listSender in VARCHAR2,
  listReceiver in VARCHAR2,
  pmax in number
);

 PROCEDURE "TEST_GETCALLDISCONNECTSTATUS" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcallType in number,
  poptionType in number,
  pcallId in VARCHAR2,
  listGroupId in VARCHAR2,
  listAgent in VARCHAR2,
  pcaller in VARCHAR2,
  pmax in number
);
PROCEDURE "TEST_GETCALLERMISSANDNOTMISS" (
 -- thong ke khach hang rot va gap nhan vien
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pjoined in number,
  pwaitTime in number,
  pmax in number
);
 PROCEDURE "TEST_GETIVRBYTIMES" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listline in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  fromN in number,
  toN in number,
  pmax in number
);
 PROCEDURE "TEST_GETIVRDETAIL" (
 -- THONG KE CHI TIET CUOC GOI KENH IVR
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  pcaller in number,
  pmax in number);
    PROCEDURE "TEST_GETIVRTOTALCALLBYDUR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  pdur1 in number,
  pdur2 in number,
  pdur3 in number,
  pdur4 in number,
  ptimeType in number,
  pmax in number
);


PROCEDURE "PROC_REPORTSURVEYPARTICIPANT" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  poptionType in number, -- 0: SMS, 1: USSD, 2: IVR
  listDtmf in VARCHAR2,
  agentId in VARCHAR2,
  pLine in VARCHAR2,
  pCaller in VARCHAR2,
  pmax in number
);
PROCEDURE "PROC_TOTALTRANSTOSURVEYIVRBYAG" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  agentId in VARCHAR2,
  listLine in VARCHAR2,
  pmax in number
) ;

PROCEDURE "PROC_TOTALTRANSTOSURVEYIVR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2,
  listLine in VARCHAR2,
  pmax in number
);
PROCEDURE "PROC_TOTALTRANSTOSURVEYSMSUSSD" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2, -- 0: tong hop, 1: chi tiet
  listCalled in VARCHAR2,
  surveyType in number,
  pmax in number
);
PROCEDURE "PROC_STATISTICTOTALCALLEDVIP" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  poptionType in VARCHAR2,
  custLevel in number,
  listLine in VARCHAR2,
  pmax in number
) ;
 PROCEDURE "PROC_REPORTCALLOUTERROR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2, -- 0: tong hop, 1: chi tiet
  listCalled in VARCHAR2,
  callId in VARCHAR2,
  agentId in VARCHAR2,
  pCaller in VARCHAR2,
  pmax in number
) ;

PROCEDURE "PROC_REPORTIVRHISTORY" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pDtmf in VARCHAR2,
  pDtmfContent in VARCHAR2,
  pmax in number
);

procedure "TESTPROC_GETAGENTCALLDETAILS" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  TODATE in date,
  PAGENTID in VARCHAR2,
  limitTime in number,
  pcaller in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in NUMBER,
  pcallid in VARCHAR2,
  pmax in NUMBER
  );
  PROCEDURE "PROC_GET_INTELLIGENT_ROUTING"
-- thong ke cuoc goi dinh tuyen
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  line in VARCHAR2,       -- danh sach queue --> 3
  routingTypeIn in number,              -- loai bao cao --> 4
  areaIn in VARCHAR2,           -- Khu vuc -> 5
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 6
);
PROCEDURE PROC_REPORTAGENTGROUPDETAIL
(
   rs in out rs_types.rs_cursor,
  agentGroupId in number,
  pVsaUser in VARCHAR2,
  listLine in VARCHAR2,
  pFromDate in Date,
  pToDate in Date,
  pmax in number
);
PROCEDURE "PROC_REPORTIVRVAS" (-- thong ke thue bao dang ky dich vu vas qua IVR
                                      rs           IN OUT rs_types.rs_cursor,
                                      fromDate     IN     DATE,
                                      toDate       IN     DATE,
                                      serviceType   IN     NUMBER,
                                      pmsisdn      IN     VARCHAR2,
                                      pReportType IN NUMBER,
                                      pResult IN NUMBER,
                                    pmax         IN     NUMBER);

PROCEDURE "PROC_REPORTCATALOGLOG" (
 -- thong ke lich su tac dong cau hinh queue
 rs in out rs_types.rs_cursor,
 fromDate in Date,
 toDate in date,
 item in number,
 actor in VARCHAR2,
 pmax in NUMBER
);
/*
-- R8247: Transfer sang nhom chuyen gia
procedure "PROC_GETCALLERTRANGROUPDETAIL" (
 rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listGroup in varchar2,
  pcaller in VARCHAR2,
  pmax in number
    );
    PROCEDURE "TESTPROC_GET_CALL_PER_PROFES" (
      rs in OUT RS_TYPES.RS_CURSOR,
     fromDate in date,
    toDate in date,
     listGroup in varchar2,
    phoneProfes in varchar2,
     LIMITTIME in number,
     POPERATOR in VARCHAR2,
      PMAX in number
    );
    PROCEDURE "TESTPROC_GETDETAILCALLPROFES"
    (
    rs in out rs_types.rs_cursor, -- --> 1
     fromDate in Date,
    TODATE in date,
     phoneProfes in varchar2,
    LISTGROUP in varchar2,
    LIMITTIME in number,
    POPERATOR in VARCHAR2,
     PMAX in number
    );
    PROCEDURE "TESTPROC_GETSUBGROUPPROFTHANN"
    (
     rs in out rs_types.rs_cursor, -- --> 1
     fromDateIn in Date,
    toDateIn in Date,
     listGroupId in VARCHAR2,
    callerIn in VARCHAR2,
      ptypeIn in number,
     ptotalCallIn in number,
     callIdIn in VARCHAR2,
     profePhone in VARCHAR2,
      acdTimeIn in VARCHAR2,
    waitingTimeIn in VARCHAR2,
    pmaxIn in number
    );
    PROCEDURE proc_getgeneralinfocalltopro (
    rs in out rs_types.rs_cursor,
     fromDate in Date,
     toDate in Date,
     listGroup in VARCHAR2,
     ptimeType in number,
      pdur1 in number,
      pdur2 in number,
     pmax in number
    );
*/

end ipcc_report;

/

