create FUNCTION "ASSERTGROUP2" 
--duongtb
    (
     agentid VARCHAR2,
     p_cursor in rs_types.rs_cursor
    )
    RETURN  number
IS
  PRAGMA AUTONOMOUS_TRANSACTION;
   rs number := 0;
   v_uname VARCHAR2(50);
   v_agent_id VARCHAR2(100) := agentid || ',';
BEGIN
   LOOP  
     FETCH p_cursor  
     INTO  v_uname;  
     EXIT WHEN p_cursor%NOTFOUND;  
     v_uname := v_uname || ',';  
     if (INSTR(agentid,v_uname) > 0) then
      rs := 1;
      exit;
     end if;
   END LOOP;  
 close p_cursor; 
 return rs;
  EXCEPTION
     when others THEN
--      INSERT_LOG('ERROR', 'Error is', SYSDATE, SUBSTR(SQLERRM, 1, 1000));
      return 0;
END;

/

