create FUNCTION "COUNT_SRV_FROM_DTMF" (dtmf1 varchar2, service1 varchar2)
      RETURN number
   IS
      result number;
   BEGIN
        WITH y AS
             (SELECT dtmf1 val FROM DUAL)
        SELECT COUNT (*) into result FROM 
        (
            SELECT SUBSTR (val,
                           (DECODE (LEVEL,1,0,INSTR (val, ';', 1, LEVEL - 1))+ 1),
                           (DECODE (INSTR (val, ';', 1, LEVEL) - 1,-1, LENGTH (val),INSTR (val, ';', 1, LEVEL) - 1))
                            - (DECODE (LEVEL,1, 0,INSTR (val, ';', 1, LEVEL - 1))+ 1)+ 1) a
            FROM y
            CONNECT BY LEVEL <=
                        (SELECT ( LENGTH (val) - LENGTH (REPLACE (val, ';', NULL)) ) FROM y)
                      + 1
        )
        WHERE a LIKE trim(service1) || '%';

        RETURN to_number(result);
   EXCEPTION
      WHEN NO_DATA_FOUND
      THEN
         RETURN 0;
   END;
---------------------

/

