create PROCEDURE           "GETGROUP" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
 userId NUMBER,
 parentId NUMBER,
 locList VARCHAR2
) AS
x_Id number;
BEGIN

--select location_id into x_id from users@tovsa where user_id = userid;


if loclist is null or loclist = '' THEN
    open rs for select distinct location_id , parent_id, location_name
    from vsa_location d start with d.location_id = x_id
    connect by prior d.location_id = d.parent_id;
else
    open rs for select distinct location_id , parent_id, location_name
    from vsa_location d where d.location_id in (
              select regexp_substr(locList,'[^,]+', 1, level) from dual
              connect by REGEXP_SUBSTR(locList, '[^,]+', 1, level) is not null )
    connect by prior d.location_id = d.parent_id
    start with d.location_id = 1;
end if;

END GETGROUP;
/*

PROCEDURE "GETGROUP" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
 userId NUMBER,
 parentId NUMBER,
 locList VARCHAR2
) AS
x_Id number;
BEGIN

select location_id into x_id from users@tovsa where user_id = userid;


if loclist is null or loclist = '' THEN
    open rs for select distinct location_id , parent_id, location_name
    from location@tovsa D start with d.location_id = x_id
    connect by prior d.location_id = d.parent_id;
else
    open rs for select distinct location_id , parent_id, location_name
    from location@tovsa d where d.location_id in (
              select regexp_substr(locList,'[^,]+', 1, level) from dual
              connect by REGEXP_SUBSTR(locList, '[^,]+', 1, level) is not null )
    connect by prior d.location_id = d.parent_id
    start with d.location_id = x_id;
end if;

END GETGROUP;*/
 

