create PROCEDURE "INSERT_DATA_ALL" (rscount OUT NUMBER) IS

  ERR_MSG VARCHAR2(1000);
  fromdate date;
BEGIN
  select trunc(sysdate-10) into fromdate from dual;
  INSERT_AGENT_INVOKE(rscount,fromdate);
  -- chen du lieu vao cac bang tong hop tu dau ngay toi thoi diem hien tai
  --INSERT_QUEUE_STAT(rscount,fromdate);
  --insert_agent_filo(rscount,fromdate); -- tong hop du lieu ve trang thai login/logout cua agent
  --insert_agent_queue_stat(rscount,fromdate); -- Tong hop cuoc goi Agent theo tung queue khoang interval 15'
  --INSERT_AGENT_CLAIM_PROCESSED(rscount,fromdate);
  --insert_chat_stat(rscount,fromdate); --tong hop du lieu chat
  --insert_mail_stat(rscount,fromdate); --tong hop du lieu email
  --INSERT_VOICEMAIL_STAT(rscount,fromdate); --tong hop du lieu voice mail
  --INSERT_CALLQUALITY_STAT(rscount,fromdate);--tong hop du lieu cham diem
  --INSERT_VOICE_STAT(rscount,fromdate);-- tong hop du lieu bao cao he thong
  --INSERT_AGENT_MODE_STAT(rscount,fromdate);--tong hop du lieu bao cao thoi gian AUX
  --tat ca cac thu tuc khac cho chay truoc insert_kpi
  --INSERT_KPI_AGENT(rscount,fromdate); --tong hop du lieu KPI cua agent
  --INSERT_KPI_SYSTEM(rscount,fromdate); --tong hop du lieu KPI cua he thong
EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'INSERT_DATA_ALL' || ERR_MSG,

  SYSDATE,

  '');
END INSERT_DATA_ALL;

/

