create PROCEDURE insert_log (P_LOG_INFO VARCHAR2,
                                       P_LOG_DESC VARCHAR,
                                       P_LOG_DATE DATE,
                                       P_LOG_SQL  VARCHAR2) IS
-- xu ly loi cannot perform a DML operation inside a query 
PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
  INSERT INTO LOG_INFO
    (LOG_ID, LOG_INFO, LOG_DESC, LOG_DATE, LOG_SQL)
  VALUES
    (LOG_INFO_SEQ.NEXTVAL, P_LOG_INFO, P_LOG_DESC, P_LOG_DATE, P_LOG_SQL);
  COMMIT;
END;

/

