create PROCEDURE "PROC_GETBLACKLISTLOG" (
 --thong ke lich su chan mo thue bao
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pmax in number
) AS
BEGIN
    open rs for select black_list_id,total_call,status,line_id, 
    to_char(last_lock_time,'yyyy-MM-dd hh24:mi:ss') as lastLockTime, 
    to_char(last_unlock_time,'yyyy-MM-dd hh24:mi:ss') lastUnLockTime, 
    last_lock_actor,last_unlock_actor,description,lock_level,caller,sms_status 
    from black_list_log 
    where insert_time between fromDate and toDate  
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%') 
    and line_id = pcalled 
    order by insert_time desc;
END PROC_GETBLACKLISTLOG;

/

