create PROCEDURE "PROC_GETCALLDISCONNECTSTATUS" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcallType in number,
  poptionType in number,
  pcallId in VARCHAR2, 
  listAgent in VARCHAR2,
  pcaller in VARCHAR2,
  pmax in number
) AS
BEGIN
  if poptiontype = 1 then
    open rs for select a.agent_id, a.caller, to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss') start_time,
      a.waiting_time, a.acd_time, 
      (case when a.in_reason = 1 then 'KH' when (a.in_reason in (2,4,5) and a.agent_id is not null) then 'do Agent' 
      when a.in_reason in (3,6,10) then 'HT' when a.in_reason = 12 
      then 'Supervisor' else 'HT' end), a.call_id, a.called,
      to_char(a.first_connect_time,'dd-MM-yyyy hh24:mi:ss') 
      from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate 
      and (listLine is null or listLine = '' or a.called = listLine) 
      and (listAgent is null or listAgent =  '' or lower(a.agent_id) = listAgent) 
      and (pcallId is null or pcallid='' or a.call_id = pcallid) 
      and (pcalltype = -1 or call_type = pcalltype) 
      and (pcaller is null or pcaller = '' or caller like '%' || pcaller ||'%')
      and rownum <= pmax
      order by a.start_time;
  else
   open rs for select b.*, c.description 
   from (select in_reason, called, count(call_id) as sumCall, count(distinct caller) as sumSub  
     from callinfo  where start_time between fromDate and toDate
      -- and insert_time between fromDate and toDate 
       and (listLine is null or listLine = '' or called = listLine) 
       and (pcalltype = -1 or call_type = pcalltype) 
       and rownum <= pmax
       group by in_reason, called order by in_reason asc) b, end_code c 
   where b.in_reason = c.end_code_id;
   end if;
END PROC_GETCALLDISCONNECTSTATUS;

/

