create PROCEDURE "PROC_GETCALLERCALLMORETHANN" (
 -- thong ke khach hang rot va gap nhan vien
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pduration in number,
  ptotalCall in number,
  pjoined in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- tong hop
    open rs for  select * from (select * from (select caller, count(distinct call_id) call_times 
    from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate
    and(pcustlevel = -1 or a.customer_level = pcustLevel) 
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')  
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    and(pcustlevel = -1 or a.customer_level = pcustLevel) 
    and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0))  
    and a.waiting_time >= pduration group by a.caller) 
    where call_times >= ptotalCall) where rownum <= pmax;
  else
   -- chi tiet
   open rs for select a.caller, to_char(a.call_start_time,'dd-MM-yyyy hh24:mi:ss') as call_start_time, 
   to_char(a.ring_time,'dd-MM-yyyy hh24:mi:ss'), to_char(a.connect_time,'dd-MM-yyyy hh24:mi:ss'), 
   to_char(a.end_time,'dd-MM-yyyy hh24:mi:ss') , a.agent_id,
   to_char(a.call_end_time,'dd-MM-yyyy hh24:mi:ss'), a.call_id, 
   to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss') 
   from call a 
  where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate
   and(pcustlevel = -1 or a.customer_level = pcustLevel) 
   and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%') 
   and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
   and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0))  
   and rownum <= pmax
   order by start_time;
  end if;
END PROC_GETCALLERCALLMORETHANN;

/

