create PROCEDURE "PROC_GETCALLERMISSANDNOTMISS" (
 -- thong ke khach hang rot va gap nhan vien
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pjoined in number,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    open rs for select distinct a.caller from callinfo a  
    where a.start_time between fromDate and toDate 
   -- and  a.insert_time between fromDate and toDate
    and (a.called = pcalled) 
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%') 
    and (pcustlevel = -1 or a.customer_level = pcustLevel)
     and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0))
    and a.waiting_time >= pwaitTime 
    and rownum <= pmax
    order by a.caller;
  else
   -- tich chon thong ke cuoc goi cuoi
    open rs for select ci.caller from callinfo ci, (select caller, max(start_time) as max_start_time 
    from callinfo a where a.start_time between fromDate and toDate 
   -- and  a.insert_time between fromDate and toDate
    and a.called = pcalled 
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%') 
    and (pcustlevel = -1 or a.customer_level = pcustLevel) group by caller) b  where ci.caller = b.caller 
    and ci.start_time = b.max_start_time  
    and ci.insert_time between fromDate and toDate  
     and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0))
    and ci.waiting_time >= pwaitTime
    and rownum <= pmax;
  end if;
END PROC_GETCALLERMISSANDNOTMISS;

/

