create PROCEDURE "PROC_GETCONFCALLDETAIL" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  in_callid in VARCHAR2, 
  in_confid in VARCHAR2,
  pmax in number
) AS
BEGIN
      open rs for select to_char(listen_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(push_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(reject_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(mc_push_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(play_start_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(play_stop_time,'dd/MM/yyyy hh24:mi:ss'), 
      to_char(mc_kickout_time,'dd/MM/yyyy hh24:mi:ss'),
      play_duration, 
      round((play_duration)/60 + 0.49)
      from conf_call_segment where call_id = in_callid
      order by listen_time;
END PROC_GETCONFCALLDETAIL;

/

