create PROCEDURE "PROC_GETCONFREPORT" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  expert in VARCHAR2,
  expertid in VARCHAR2,
  agentid in VARCHAR2, 
  deviceid in VARCHAR2,
  mc in VARCHAR2, 
  mcid in VARCHAR2, 
  in_caller in VARCHAR2,
  listConfId in VARCHAR2,
  in_callid in VARCHAR2, 
  ptimetype in number,
  reporttype in NUMBER, 
  reportid in VARCHAR2,
  pmax in number
) AS

cout NUMBER := 0;
BEGIN
--insert into tbltest(id, val) values(test_seq.nextval, listline);
--insert into tbltest(id, val) values(test_seq.nextval, listconfid);

COMMIT;
-- thong ke chi tiet cuoc goi
  if reportid = 'CR001' then
      open rs for select a.call_id,a.caller,a.expert_id,a.expert_uname,a.agent_id,a.agent_uname,to_char(a.agent_connect_time,'dd/MM/yyyy hh24:mi:ss'), 
      to_char(a.join_start_time,'dd/MM/yyyy hh24:mi:ss'),to_char(a.expert_connect_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(a.join_stop_time,'dd/MM/yyyy hh24:mi:ss'),a.call_duration, a.mc_id,a.mc_uname, round (a.call_duration/60 + 0.499),b.conf_title
      from conf_call a, conference@toacd b 
      where a.join_start_time between fromDate and toDate and a.conf_code=b.conf_code
      and (listLine is null or listLine = '' or a.called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))   
      and (expert is null or expert = '' or lower(a.expert_uname) like '%' || expert || '%')
      and (expertid is null or expertid = '' or a.expert_id like '%' || expertid || '%')
      and (agentid is null or agentid = '' or lower(a.agent_uname) like '%' || agentid || '%')
      and (deviceid is null or deviceid = '' or a.agent_id like '%' || deviceid || '%')
      and (mc is null or mc = '' or lower(a.mc_uname) like '%' || mc || '%')
      and (mcid is null or mcid = '' or a.mc_id like '%' || mcid || '%')
      and (in_caller is null or in_caller = '' or a.caller like '%' || in_caller || '%')
      and (listConfId is null or listConfId = '' or a.conf_code in (
            select regexp_substr(listConfId,'[^,]+', 1, level) from dual
            connect by regexp_substr(listConfId, '[^,]+', 1, level) is not null ))
      order by join_start_time;
--      dbms_output.put_line('cout:' || cout);
  end if;
-- thong ke cuoc goi khach hang
  if reportid = 'CR002' then
      open rs for select caller, count(*) as solangoi, sum(push_count) as solanyeucau, 
      sum (case when join_count >0 then 1 else 0 end) as socuocgapchuyengia, 
      sum(agent_delay_duration), sum(listen_duration), sum(join_duration), 
      sum(agent_delay_duration + listen_duration + join_duration), 
      sum (round((agent_delay_duration + listen_duration + join_duration)/60 + 0.499))
      from conf_call where join_start_time between fromDate and toDate
      and (listLine is null or listLine = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))  
      and (expert is null or expert = '' or lower(expert_uname) like '%' || expert || '%')
      and (expertid is null or expertid = '' or expert_id like '%' || expertid || '%')
      and (in_caller is null or in_caller = '' or caller like '%' || in_caller || '%')
      and (listConfId is null or listConfId = '' or conf_code in (
            select regexp_substr(listConfId,'[^,]+', 1, level) from dual
            connect by regexp_substr(listConfId, '[^,]+', 1, level) is not null ))
      group by caller order by caller;
  end if;
  -- thong ke cuoc goi theo chuyen gia
  if reportid = 'CR003' then
      open rs for select a.expert_id, a.expert_uname, count(*) as tongsocuoc, count(distinct a.caller) as tongthuebaovao, 
      count(distinct case when a.join_count = 0 then a.caller end) as tongsothuebaoroi, 
      count(distinct case when a.push_count > 0 then a.caller end) as tongsothuebaoyeucaugap, 
      count(distinct case when a.reject_count > 0 then a.caller end) as tongsothuebaohuy, 
      count(distinct case when a.join_count > 0 then a.caller end) as tongdagap, 
      sum(a.total_duration), sum(round(a.total_duration/60 + 0.499)) ,b.conf_title,a.confcall_id
      from conf_call a, conference@toacd b 
      where a.join_start_time between fromDate and toDate  
      and a.conf_code=b.conf_code
      and (listLine is null or listLine = '' or a.called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
      and (expert is null or expert = '' or lower(a.expert_uname) like '%' || expert || '%')
      and (expertid is null or expertid = '' or a.expert_id like '%' || expertid || '%')
      and (listConfId is null or listConfId = '' or a.conf_code in (
            select regexp_substr(listConfId,'[^,]+', 1, level) from dual
            connect by regexp_substr(listConfId, '[^,]+', 1, level) is not null ))
      group by expert_id,expert_uname,b.conf_title,a.confcall_id order by expert_uname;
  end if;

END PROC_GETCONFREPORT;

/

