create PROCEDURE "PROC_GETLISTAGENT_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in TIMESTAMP,
  toDate in TIMESTAMP,
  pagentid in varchar2,
  pminduration in number,
  prownum in number
) AS
begin
     open RS for
              select agent_id, count(*) from call
              where start_time between fromDate and toDate
              and  answer_time >= pminduration
              and url is not null
              and connect_time is not null
              and call_type = 0
              and (pagentid is null or pagentid = '' or agent_id = pagentid)
            --  and rownum <= prownum
              group by agent_id
 ;
END PROC_GETLISTAGENT_WS;

/

