create PROCEDURE "PROC_GETLISTCALLBYCALLER_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in TIMESTAMP,
  toDate in TIMESTAMP,
  pcaller in varchar2,
  pagentid in varchar2,
  pminduration in number
) AS
begin
     open RS for
              select agent_id,
              to_char(start_time,'yyyy-MM-dd hh24:mi:ss'),
              to_char(ring_time,'yyyy-MM-dd hh24:mi:ss'),
              to_char(connect_time,'yyyy-MM-dd hh24:mi:ss'),
              to_char(end_time,'yyyy-MM-dd hh24:mi:ss'),
              answer_time as conference_time,url,caller,called
              from call where start_time between fromDate and toDate
              and (pcaller is null or pcaller = '' or caller like '%'||pcaller||'%')
              and (pagentid is null or pagentid = '' or agent_id = pagentid)
              and  answer_time >= pminduration
              and   url is not null
              and connect_time is not null
              and call_type = 0
              order by agent_id
 ;
END PROC_GETLISTCALLBYCALLER_WS;

/

