create PROCEDURE "PROC_SCAN_TO_CALL_OUT" (num in number) 
--loc danh sach khach hang goi ra
IS
  mx_dt number := 15*24*60*60;
  number_rec number := 0;
  TYPE cur_typ IS REF CURSOR;
  caller_rs cur_typ;
--  luu so thue bao
  v_caller VARCHAR2(50);
  CURSOR filter_rs
  IS
--  lay ra cac bo dieu kien loc cua nhung lich goi ra thoa man
--  lay ra dieu kien loc cho phep, thoi gian tu ngay trong dieu kien loc khong duoc chenh lech voi thoi diem hien tai 15 ngay
  select * from callout_customer_filter where callout_schedule_id in (
    select callout_schedule_id from callout_schedule where ((option_type = 0 and to_date >= sysdate) or option_type = 1) and active != 0) and (round(sysdate - from_date)*24*60*60) < mx_dt;
    filter_rec filter_rs%rowtype;
BEGIN
-- duyet qua bo dieu kien loc tuong ung voi nhung lich goi ra duoc phep
  FOR filter_rec IN filter_rs
  LOOP
-- lay ra danh sach khach hang theo dieu kien loc
-- select * () where rownum <= x voi cac cau lenh co group by neu khong ket qua se khong dung
    OPEN caller_rs for select * from (select caller from callinfo where insert_time between filter_rec.from_date and filter_rec.to_date and start_time >= filter_rec.from_date and start_time <= filter_rec.to_date
    and called = filter_rec.line and duration >= filter_rec.time_of_call             
    group by caller having count(*) >= filter_rec.number_call) where rownum <= 1000;               
--    duyet qua cac caller quet duoc de cap nhat vao bang callout_customer
      LOOP
        FETCH caller_rs 
          INTO v_caller;
--          kiem tra xem khach hang da duoc cap nhat vao callout_customer trong thoi gian goi ra chua
--          select count(callout_schedule_id) into number_rec from callout_customer where caller = v_caller and act_time > filter_rec.from_date and act_time < filter_rec.to_date;
          select count(*) into number_rec from callout_customer where caller = v_caller and callout_schedule_id = filter_rec.callout_schedule_id and line = filter_rec.line;
          if number_rec = 0
            then
--            chua ton tai thi them vao
              insert into callout_customer(callout_customer_id, callout_schedule_id, status, line, total_call, active, caller, act_time,actor)
              values (callout_customer_seq.nextval, filter_rec.callout_schedule_id,1, filter_rec.line, 0 , 1 , v_caller,sysdate,'system');
          end if;
        EXIT WHEN caller_rs%NOTFOUND;
      END LOOP;
--      het 1 dieu kien loc
      commit;
  CLOSE caller_rs;
  END LOOP;
END;

/

