create PROCEDURE "TESTPROC_GETACTIONOFAGENT" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listGroupId in VARCHAR2,
  agentName in VARCHAR2,
  listLine in VARCHAR2,
  listAction in number,  
  pmax in number
) AS
BEGIN
  open rs for select * from (select a.agent_id,b.trans_type_name,count(agent_id) as solan  
  from trans_info a, trans_type b  where 
  a.insert_time between fromDate and toDate 
  and a.trans_type = b.trans_type_code
  and a.call_start_time between fromDate and toDate 
   and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
  and (agentName is null or agentName = '' or lower(a.agent_id) like '%' || agentName ||'%')
  and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
  and (listAction is null or listAction = '' or a.trans_type in (
      select regexp_substr(listAction,'[^,]+', 1, level) from dual
      connect by regexp_substr(listAction, '[^,]+', 1, level) is not null )) 
  group by a.agent_id, b.trans_type_name order by a.agent_id asc) where rownum <= pmax;
  
END testPROC_GETACTIONOFAGENT;


-----------

/

