create trigger INSERT_TIME_RANGE
  before insert
  on TD_TIME_RANGE
  for each row
  DECLARE
  p_error varchar2(500);
BEGIN

IF(:new.TIME_RANGE_ID is null )
THEN select  TIME_RANGE_SEQ.nextval  into :new.TIME_RANGE_ID from dual;
END IF;
  
EXCEPTION
   WHEN others THEN
    Raise_Application_Error('-20000','Exception INSERT_TIME_RANGE :'||sqlerrm);
END;

/

