create FUNCTION "CHECK_CALL_MISS" (call_id1 varchar)
      RETURN number
   IS
      result   number;
   BEGIN
        select count(b.connect_time)
        into result
        FROM call b
        WHERE b.call_id = call_id1;
        
        if 
            result > 0
        then 
            RETURN 1;
        else 
            return 0;
        end if;
        return 0;
   EXCEPTION
      WHEN NO_DATA_FOUND
      THEN
         RETURN 0;
      WHEN OTHERS
      THEN
         RETURN 0;
   END;
-------------------------

/

