create PROCEDURE "PARTITION_DEL_FULLSCAN" (DAY_NUM  IN NUMBER) IS
  ERR_MSG       VARCHAR2(1000);

BEGIN
  del_data('AGENT', day_num);
  del_data('CALL', day_num);
  del_data('CALLINFO', day_num);
  del_data('DTMF_LOG', day_num);
  del_data('TRANS_INFO', day_num);
  del_data('BLACK_LIST_LOG', 90);
  del_data_chat('CHAT_MESSAGE',90);
  del_data_chat('CHAT_CONFERENCE',90);
EXCEPTION
  WHEN OTHERS THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('ERROR ','Error is:' || ERR_MSG,SYSDATE,'partition_del_fullscan');
    ROLLBACK;
END partition_del_fullscan;

/

