create PROCEDURE "PROC_GETACTIONOFAGENT" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listAgent in VARCHAR2,
  listLine in VARCHAR2,
  pAction in number,  
  pmax in number
) AS
BEGIN
  open rs for select a.agent_id,b.trans_type_name,count(agent_id) as solan  
  from trans_info a, trans_type b  where a.trans_type = b.trans_type_code
  and a.call_start_time between fromDate and toDate 
  and (listAgent is null or listAgent = '' or lower(agent_id) in (
      select regexp_substr(listAgent,'[^,]+', 1, level) from dual
      connect by regexp_substr(listAgent, '[^,]+', 1, level) is not null )) 
  and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
  and a.trans_type = pAction
  group by a.agent_id, b.trans_type_name order by a.agent_id asc;
  
END PROC_GETACTIONOFAGENT;

/

