create PROCEDURE "PROC_GETAGENTJOBSTATUS" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listAgent in VARCHAR2,
  pstatus in number,
  poptionType in number,
  pdur1 in number,
  pdur2 in NUMBER, 
  pdur3 in NUMBER, 
  pdur4 in number,
  pmax in number
) AS
BEGIN
--  tam thoi chi tim kiem chinh xac theo agent_id
  if poptiontype = 0 then
     open rs for select a.agent_id, sum(case when a.duration > pdur1 and a.duration <=pdur2 then 1 else 0 end) as ringt1t2, 
     sum(case when a.duration > pdur2 and a.duration <= pdur3 then 1 else 0 end) as ringt2t3, 
     sum(case when a.duration > pdur3 and a.duration <= pdur4 then 1 else 0 end) as ringt3t4, 
     sum(case when a.duration > pdur4 then 1 else 0 end) as ringt4, 
     sum(duration) as total_ring_time,count(status) as total, b.status_name 
     from agent a,agent_status b where a.start_time between fromDate and toDate
    -- and a.insert_time between fromDate and toDate 
     and a.status = b.status_code 
     and (pstatus = -1 or a.status = pstatus) 
     and (listAgent is null or listAgent = '' or lower(a.agent_id) = listAgent)
     and rownum <= pmax
     group by a.agent_id,b.status_name;
   else
      open rs for select a.agent_id, a.status, to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss'),
      a.duration,to_char(a.stop_time,'dd-MM-yyyy hh24:mi:ss'),b.status_name 
      from agent a, agent_status b where a.start_time between fromDate and toDate
    -- and a.insert_time between fromDate and toDate 
      and a.status = b.status_code 
      and b.status_type = 1 
      and (pstatus =-1 or a.status = pstatus)
      and (listAgent is null or listAgent = '' or lower(a.agent_id) = listAgent) 
      and rownum <= pmax
      order by a.agent_id,a.start_time;
   end if;
END PROC_GETAGENTJOBSTATUS;

/

