create PROCEDURE "PROC_GETAGENTWORKFORCE" (
  -- thong ke thoi gian trang thai
   rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listAgent in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in number,
  plimitTime in NUMBER,
  pmax in number
) AS
BEGIN
  open rs for select a.agent_id, a.called, count(*),
  round(avg((a.connect_time - a.ring_time)* 24*60*60)),
  round(avg((a.end_time - a.connect_time)* 24*60*60)),
  round(max((a.connect_time - a.ring_time)* 24*60*60)),
  round(max((a.end_time - a.connect_time) * 24*60*60)),
  (sum((a.end_time - a.connect_time) * 24*60)),
  count(case when a.end_code in (2, 4, 5) then a.call_id end) 
  from call a where a.start_time between fromDate and toDate
  --and  a.insert_time between fromDate and toDate
   and (listAgent is null or listAgent = '' or lower(agent_id) in (
      select regexp_substr(listAgent,'[^,]+', 1, level) from dual
      connect by regexp_substr(listAgent, '[^,]+', 1, level) is not null )) 
  and (pcalltype = -1 or a.call_type = pcalltype)
   and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
  and a.connect_time is not null 
  and round((a.end_time - a.connect_time)*24*60*60) >= plimittime
  group by a.agent_id, a.called;
  
END PROC_GETAGENTWORKFORCE;

/

