create PROCEDURE "PROC_GETANSWERCALLDETAILS" (
 -- thong ke so cuoc tra loi cua Agent
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listAgent in VARCHAR2,
  limitTime in number,
  pcaller in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in NUMBER,
  pcallid in VARCHAR2,
  pdeviceId in VARCHAR2,
  pmax in NUMBER
  
) IS
  row_count number;
begin
  row_count := pmax;
  open rs for select agent_id, to_char(start_time,'yyyy-MM-dd hh24:mi:ss'), 
    to_char(ring_time,'yyyy-MM-dd hh24:mi:ss'), 
    to_char(connect_time,'yyyy-MM-dd hh24:mi:ss'), 
    to_char(end_time,'yyyy-MM-dd hh24:mi:ss'),  
    answer_time as conference_time,
    url,caller,called,call_id,call_type,device_id 
  from call where start_time between fromDate and toDate
    --and  insert_time between fromDate and toDate 
    and (listAgent is null or listAgent = '' or lower(agent_id) in (
      select regexp_substr(listAgent,'[^,]+', 1, level) from dual
      connect by regexp_substr(listAgent, '[^,]+', 1, level) is not null )) 
    and connect_time is not null 
    and answer_time >= limittime 
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller ||'%')
    and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    and (pcalltype = -1 or call_type = pcalltype) 
    and (pcallid is null or pcallid = '' or lower(call_id) = pcallId) 
    and (pdeviceid is null or pdeviceid = '' or device_id = pdeviceId) 
    and rownum <= row_count
  order by start_time;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
  DBMS_OUTPUT.PUT_LINE('Row count = ' || row_count);
end proc_getAnswerCallDetails;

/

