create PROCEDURE "PROC_GETCALLBYMM" (
 -- thong ke cuoc goi theo phut (kenh IVR)
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
  if ptype = 1 then
    -- theo gio
    open rs for select to_char(trunc(a.start_time,'hh24'),'dd-MM-yyyy hh24:mi:ss') as date_hour, 
    a.called , count(distinct a.call_id) as totalCalls, 
    count(distinct a.caller) as totalCallers, 
    round(a.duration/60 + 0.5) as totalTimes 
    from callinfo a where a.start_time between fromDate and toDate
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))   
    group by trunc(a.start_time,'hh24'),a.called, round(a.duration/60 + 0.5); 
  else
  -- theo ngay
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour, 
    a.called , count(distinct a.call_id) as totalCalls, 
    count(distinct a.caller) as totalCallers, 
    round(a.duration/60 + 0.5) as totalTimes 
    from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate 
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    group by trunc(a.start_time),a.called, round(a.duration/60 + 0.5); 
  end if;
END PROC_GETCALLBYMM;

/

