create PROCEDURE "PROC_GETCOLLECTCALLACD_OMAP2" (
   rs
/*ADVICE(3): An IN OUT parameter used as OUT only [104] */
                   IN OUT   rs_types.rs_cursor
/*ADVICE(5): This item has not been declared, or it refers to a label
              [131] */
                                              ,
   fromdate        IN       DATE,
   todate          IN       DATE,
   listline        IN       VARCHAR2,
   listline1       IN       VARCHAR2,
   sltreporttype   IN       NUMBER,
   chkgroupby      IN       NUMBER,
   timetype        IN       NUMBER,
   groupname       IN       VARCHAR2,
   agentuname      IN       VARCHAR2,
   pcallid         IN       VARCHAR2,
   numbercaller    IN       VARCHAR2,
   pdeviceid       IN       VARCHAR2,
   pmax            IN       NUMBER
)
AS
BEGIN
--to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi:ss')
 /* Thong ke tong hop, nhom theo agent khong duoc chon*/
 -- Theo ngay
   IF sltreporttype = 0 AND chkgroupby = -1 AND timetype = 0
   THEN
      OPEN rs FOR
         SELECT   TO_CHAR (TRUNC (a.start_time), 'dd/mm/yyyy') date_hour,
                  called, COUNT (DISTINCT a.caller) AS tongsothuebao,
                  COUNT (DISTINCT a.call_id) AS tongsocuoc
             FROM callinfo a
            WHERE a.start_time BETWEEN fromdate AND todate
              AND (   listline IS NULL
                   OR listline = ''
/*ADVICE(37): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */
                   OR called IN (
                         SELECT     REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL)
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL) IS NOT NULL)
                  )
              AND (   listline1 IS NULL
                   OR listline1 = ''
/*ADVICE(49): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */
                   OR transfer_called
/*ADVICE(53): This item has not been declared, or it refers to a label
              [131] */
                          IN (
                         SELECT     REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  )
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  ) IS NOT NULL)
                  )
             
              AND (   agentuname IS NULL
                   OR agentuname = ''
/*ADVICE(88): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(transfer_agent_uname)
/*ADVICE(92): This item has not been declared, or it refers to a label
              [131] */
                                          LIKE '%' || lower(agentuname) || '%'
                  )
              AND (   pcallid IS NULL
                   OR pcallid = ''
/*ADVICE(98): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(call_id)
/*ADVICE(102): This item has not been declared, or it refers to a label
              [131] */
                             LIKE '%' || lower(pcallid) || '%'
                  )
              AND (   numbercaller IS NULL
                   OR numbercaller = ''
/*ADVICE(108): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR caller
/*ADVICE(112): This item has not been declared, or it refers to a label
              [131] */
                            LIKE '%' || numbercaller || '%'
                  )
              AND (   pdeviceid IS NULL
                   OR pdeviceid = ''
/*ADVICE(118): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_device_id
/*ADVICE(122): This item has not been declared, or it refers to a label
              [131] */
                                        LIKE '%' || pdeviceid || '%'
                  )
              AND ROWNUM <= pmax
         GROUP BY TRUNC (a.start_time), called
/*ADVICE(128): Elements in the SELECT list (either columns or expressions) are
              not qualified by a table/view name [403] */

         ORDER BY date_hour
/*ADVICE(132): This item has not been declared, or it refers to a label
              [131] */
                           DESC;
-- Thong ke tong hop theo gio : agent khong duoc chon
   ELSIF sltreporttype = 0 AND chkgroupby = -1 AND timetype = 1
   THEN
      OPEN rs FOR
         SELECT   TO_CHAR (TRUNC (a.start_time, 'hh24'),
                           'dd/mm/yyyy hh24:mi:ss'
                          ) date_hour,
                  called, COUNT (DISTINCT a.caller) AS tongsothuebao,
                  COUNT (DISTINCT a.call_id) AS tongsocuoc
             FROM callinfo a
            WHERE a.start_time BETWEEN fromdate AND todate
              AND (   listline IS NULL
                   OR listline = ''
/*ADVICE(148): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR called IN (
                         SELECT     REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL)
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL) IS NOT NULL)
                  )
              AND (   listline1 IS NULL
                   OR listline1 = ''
/*ADVICE(160): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_called
/*ADVICE(164): This item has not been declared, or it refers to a label
              [131] */
                          IN (
                         SELECT     REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  )
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  ) IS NOT NULL)
                  )
             
            
              AND (   agentuname IS NULL
                   OR agentuname = ''
/*ADVICE(199): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(transfer_agent_uname)
/*ADVICE(203): This item has not been declared, or it refers to a label
              [131] */
                                          LIKE '%' || lower(agentuname) || '%'
                  )
              AND (   pcallid IS NULL
                   OR pcallid = ''
/*ADVICE(209): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(call_id)
/*ADVICE(213): This item has not been declared, or it refers to a label
              [131] */
                             LIKE '%' || lower(pcallid) || '%'
                  )
              AND (   numbercaller IS NULL
                   OR numbercaller = ''
/*ADVICE(219): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR caller
/*ADVICE(223): This item has not been declared, or it refers to a label
              [131] */
                            LIKE '%' || numbercaller || '%'
                  )
              AND (   pdeviceid IS NULL 
                   OR pdeviceid = ''
/*ADVICE(229): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_device_id
/*ADVICE(233): This item has not been declared, or it refers to a label
              [131] */ 
                                        LIKE '%' || pdeviceid || '%'
                  )
              AND ROWNUM <= pmax
         GROUP BY TRUNC (a.start_time, 'hh24'), called
/*ADVICE(239): Elements in the SELECT list (either columns or expressions) are
              not qualified by a table/view name [403] */

         ORDER BY date_hour
/*ADVICE(243): This item has not been declared, or it refers to a label
              [131] */
                           DESC;
    /* Thong ke tong hop, nhom theo agent duoc chon*/
--    Theo ngay
   ELSIF sltreporttype = 0 AND chkgroupby = 1 AND timetype = 0
   THEN
      OPEN rs FOR
         SELECT   TO_CHAR (TRUNC (a.start_time), 'dd/mm/yyyy') date_hour,
                  called, transfer_agent_uname, COUNT (*) AS tongsocuoc
             FROM callinfo a
            WHERE a.start_time BETWEEN fromdate AND todate
              AND (   listline IS NULL
                   OR listline = ''
/*ADVICE(257): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR called IN (
                         SELECT     REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL)
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL) IS NOT NULL)
                  )
              AND (   listline1 IS NULL
                   OR listline1 = ''
/*ADVICE(269): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_called
/*ADVICE(273): This item has not been declared, or it refers to a label
              [131] */
                          IN (
                         SELECT     REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  )
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  ) IS NOT NULL)
                  )
             
           
              AND (   agentuname IS NULL
                   OR agentuname = ''
/*ADVICE(308): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(transfer_agent_uname)
/*ADVICE(312): This item has not been declared, or it refers to a label
              [131] */
                                          LIKE '%' || lower(agentuname) || '%'
                  )
              AND (   pcallid IS NULL
                   OR pcallid = ''
/*ADVICE(318): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR call_id
/*ADVICE(322): This item has not been declared, or it refers to a label
              [131] */
                             LIKE '%' || pcallid || '%'
                  )
              AND (   numbercaller IS NULL
                   OR numbercaller = ''
/*ADVICE(328): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR caller
/*ADVICE(332): This item has not been declared, or it refers to a label
              [131] */
                            LIKE '%' || numbercaller || '%'
                  )
              AND (   pdeviceid IS NULL
                   OR pdeviceid = ''
/*ADVICE(338): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_device_id
/*ADVICE(342): This item has not been declared, or it refers to a label
              [131] */
                                        LIKE '%' || pdeviceid || '%'
                  )
              AND ROWNUM <= pmax
         GROUP BY TRUNC (a.start_time), transfer_agent_uname, called
/*ADVICE(348): Elements in the SELECT list (either columns or expressions) are
              not qualified by a table/view name [403] */

         ORDER BY date_hour
/*ADVICE(352): This item has not been declared, or it refers to a label
              [131] */
                           ;
   --Theo gio
   ELSIF sltreporttype = 0 AND chkgroupby = 1 AND timetype = 1
   THEN
      OPEN rs FOR
         SELECT   TO_CHAR (TRUNC (a.start_time, 'hh24'),
                           'dd/mm/yyyy hh24:mi:ss'
                          ) date_hour,
                  called, transfer_agent_uname, COUNT (*) AS tongsocuoc
             FROM callinfo a
            WHERE a.start_time BETWEEN fromdate AND todate
              AND (   listline IS NULL
                   OR listline = ''
/*ADVICE(367): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR called IN (
                         SELECT     REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL)
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL) IS NOT NULL)
                  )
              AND (   listline1 IS NULL
                   OR listline1 = ''
/*ADVICE(379): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_called
/*ADVICE(383): This item has not been declared, or it refers to a label
              [131] */
                          IN (
                         SELECT     REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  )
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  ) IS NOT NULL)
                  )
           
            
              AND (   agentuname IS NULL
                   OR agentuname = ''
/*ADVICE(418): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(transfer_agent_uname)
/*ADVICE(422): This item has not been declared, or it refers to a label
              [131] */
                                          LIKE '%' || lower(agentuname) || '%'
                  )
              AND (   pcallid IS NULL
                   OR pcallid = ''
/*ADVICE(428): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(call_id)
/*ADVICE(432): This item has not been declared, or it refers to a label
              [131] */
                             LIKE '%' || lower(pcallid) || '%'
                  )
              AND (   numbercaller IS NULL
                   OR numbercaller = ''
/*ADVICE(438): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR caller
/*ADVICE(442): This item has not been declared, or it refers to a label
              [131] */
                            LIKE '%' || numbercaller || '%'
                  )
              AND (   pdeviceid IS NULL
                   OR pdeviceid = ''
/*ADVICE(448): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_device_id
/*ADVICE(452): This item has not been declared, or it refers to a label
              [131] */
                                        LIKE '%' || pdeviceid || '%'
                  )
              AND ROWNUM <= pmax
         GROUP BY TRUNC (a.start_time, 'hh24'), transfer_agent_uname, called
/*ADVICE(458): Elements in the SELECT list (either columns or expressions) are
              not qualified by a table/view name [403] */

         ORDER BY date_hour
/*ADVICE(462): This item has not been declared, or it refers to a label
              [131] */
                           ;
   /* thong ke chi tiet*/
   ELSE
      OPEN rs FOR
         SELECT   call_id, caller, called, transfer_device_id, call_type,
                  TO_CHAR (a.start_time, 'dd/mm/yyyy hh24:mi:ss') date_hour,
                  to_char(a.first_connect_time, 'dd/mm/yyyy hh24:mi:ss') first_connect_time, transfer_agent_uname, transfer_time,
                  transfer_called
             FROM callinfo a
            WHERE a.start_time BETWEEN fromdate AND todate
              AND (   listline IS NULL
                   OR listline = ''
/*ADVICE(476): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR called IN (
                         SELECT     REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL)
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1,
                                                   LEVEL) IS NOT NULL)
                  )
              AND (   listline1 IS NULL
                   OR listline1 = ''
/*ADVICE(488): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_called
/*ADVICE(492): This item has not been declared, or it refers to a label
              [131] */
                          IN (
                         SELECT     REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  )
                               FROM DUAL
                         CONNECT BY REGEXP_SUBSTR (listline1,
                                                   '[^,]+',
                                                   1,
                                                   LEVEL
                                                  ) IS NOT NULL)
                  )
               
             
              AND (   agentuname IS NULL
                   OR agentuname = ''
/*ADVICE(527): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(transfer_agent_uname)
/*ADVICE(531): This item has not been declared, or it refers to a label
              [131] */
                                          LIKE '%' || lower(agentuname) || '%'
                  )
              AND (   pcallid IS NULL
                   OR pcallid = ''
/*ADVICE(537): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR lower(call_id)
/*ADVICE(541): This item has not been declared, or it refers to a label
              [131] */
                             LIKE '%' || lower(pcallid) || '%'
                  )
              AND (   numbercaller IS NULL
                   OR numbercaller = ''
/*ADVICE(547): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR caller
/*ADVICE(551): This item has not been declared, or it refers to a label
              [131] */
                            LIKE '%' || numbercaller || '%'
                  )
              AND (   pdeviceid IS NULL
                   OR pdeviceid = ''
/*ADVICE(557): In Oracle 8 strings of zero length assigned to CHAR variables
              will blank-pad these rather than making them NULL [111] */

                   OR transfer_device_id
/*ADVICE(561): This item has not been declared, or it refers to a label
              [131] */
                                        LIKE '%' || pdeviceid || '%'
                  )
              AND ROWNUM <= pmax
/*ADVICE(566): Elements in the SELECT list (either columns or expressions) are
              not qualified by a table/view name [403] */

--                group by TRUNC(a.start_time,'hh24')
         ORDER BY date_hour
/*ADVICE(571): This item has not been declared, or it refers to a label
              [131] */
                           ;
   END IF;
END proc_getcollectcallacd_omap2;

/

