create PROCEDURE "PROC_GETIVRBYTIMES" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  fromN in number,
  toN in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- THEO SO LAN: TINH TONG SO CUOC GOI = SO LAN * TONG SO THUE BAO
    open rs for select byN, count(byN), called 
    from (select a.called, count(a.call_id) as byN 
        from dtmf_log a where a.start_time  between fromDate and toDate 
        and a.called=pcalled group by a.called, a.caller)  
    where byN between fromN and toN  group by called, byN 
    order by called desc, byN asc;
  else
     -- THEO THUE BAO
     open rs for select caller, sumCall, sumDuration 
     from (select a.caller, count(a.call_id) as sumCall, sum(a.duration) as sumDuration 
     from dtmf_log a 
     where a.start_time between fromDate and toDate  
     and a.called=pcalled 
     and (pcaller is null or pcaller = '' or a.caller like '%' || pcaller || '%') 
     group by a.caller)  
     where sumCall between fromN and toN   
     order by sumCall asc, sumDuration asc;
  end if;
END PROC_GETIVRBYTIMES;

/

