create PROCEDURE "PROC_SCAN_TO_LOCK" (num out number) 
--Author: duongtb
IS

  limit_rec number := 1000;
  TYPE t_call_total IS TABLE OF NUMBER;
  TYPE t_caller IS TABLE OF callinfo.caller%TYPE;
  number_rec number := 0;
  TYPE cur_typ IS REF CURSOR;
  caller_rs cur_typ;
--  khai bao con tro luat
  rule_rs cur_typ;
--  luu so thue bao
  v_caller t_caller;
--  luu tong so cuoc goi
  v_call_total t_call_total;
  sysdt date := to_date(to_char(sysdate, 'dd/MM/yyyy'),'dd/MM/yyyy');
  limit_date date := sysdt;
  d_in_month number := to_number(to_char(sysdate,'DD'));
  d_in_week number := to_number(to_char(sysdate,'D'));
  t_max_dur number := 0;
  t_max_num number := 0;
  t_line_id VARCHAR2(50);
  t_count number := 0;
  CURSOR filter_rs
    IS
  --  lay ra cac bo dieu kien loc mac dinh theo kenh 
    select * from line_param;
      filter_rec filter_rs%rowtype;
BEGIN
-- duyet qua bo dieu kien loc mac dinh theo kenh
  FOR filter_rec IN filter_rs
  LOOP
      t_line_id := filter_rec.line_id;
      t_max_dur := filter_rec.max_duration_call;
      t_max_num := filter_rec.max_num_call;
--  duyet qua tat ca cac kenh, xu ly uu tien luat theo tung kenh
    select count(*) into t_count from rule_exception where working_start_time <= sysdt and working_stop_time >= sysdt 
    and ((rule_type_id = 0 and mod(round(sysdt - working_start_time), day_cycle_usage) = 0)
      or (rule_type_id = 1 and (monday = d_in_week or tuesday = d_in_week or wednesday = d_in_week or thursday = d_in_week or friday= d_in_week or saturday= d_in_week or sunday= d_in_week))
      or (rule_type_id = 2 and day_usage = d_in_month)
    )
    and line_id = t_line_id
    order by rule_type_id asc, insert_time desc;
   
    if t_count > 0 then
           select line_id,max_duration_call, max_num_call into t_line_id, t_max_dur, t_max_num from (select line_id, max_duration_call, max_num_call from rule_exception where working_start_time <= sysdt and working_stop_time >= sysdt 
            and ((rule_type_id = 0 and mod(round(sysdt - working_start_time), day_cycle_usage) = 0)
              or (rule_type_id = 1 and (monday = d_in_week or tuesday = d_in_week or wednesday = d_in_week or thursday = d_in_week or friday= d_in_week or saturday= d_in_week or sunday= d_in_week))
              or (rule_type_id = 2 and day_usage = d_in_month)
            )
            and line_id = t_line_id
            order by rule_type_id asc, insert_time desc) where rownum <= 1;
    end if;
    DBMS_OUTPUT.PUT_LINE('to_day = ' || d_in_month);
    DBMS_OUTPUT.PUT_LINE('to_day in week = ' || d_in_week);
    DBMS_OUTPUT.PUT_LINE('t_line_id = ' || t_line_id);
    DBMS_OUTPUT.PUT_LINE('t_max_dur = ' || t_max_dur);
    DBMS_OUTPUT.PUT_LINE('t_max_num = ' || t_max_num);
--  ket thuc xu ly uu tien luat
-- lay ra danh sach khach hang theo dieu kien loc 
    OPEN caller_rs for select caller, count(*) as call_total from callinfo where start_time >= limit_date
    and called = t_line_id and acd_time >= t_max_dur 
    group by caller having count(*) >= t_max_num;       
--    duyet qua cac caller quet duoc de cap nhat 
      LOOP
        FETCH caller_rs bulk collect
          INTO v_caller, v_call_total limit limit_rec;
             EXIT WHEN v_caller.COUNT = 0;               
              FOR i IN v_caller.FIRST .. v_caller.LAST
                 LOOP
--                      kiem tra xem khach hang da duoc cap nhat vao BlackList theo kenh
                      select count(*) into number_rec from black_list where caller = v_caller(i) and line_id = t_line_id;
                      DBMS_OUTPUT.PUT_LINE('num_rec = ' || number_rec);
                    if number_rec > 0 then
                        select count(*) into number_rec from black_list where caller = v_caller(i) and line_id = t_line_id and status = 0;
                        if number_rec > 0 then
                          update black_list set status = 1,lock_level=1,total_call = v_call_total(i), last_lock_time = sysdate, last_lock_actor='System', insert_time=sysdate, is_sent=0, is_actual_change=1, is_request_unlock=0 
                          where caller = v_caller(i) and line_id = t_line_id;
                        end if;
                    else 
                        insert into black_list(black_list_id, caller, status, sms_status, lock_level, total_call,line_id,last_lock_time, last_lock_actor, insert_time,is_sent, is_actual_change, is_request_unlock) 
                        values(blacklist_seq.nextval,v_caller(i), 1, 0, 1, v_call_total(i), t_line_id, sysdate,'System',sysdate,0,1,0);
                    end if;
                    num := num + 1;
                 END LOOP;

              
--        
        EXIT WHEN caller_rs%NOTFOUND;
      END LOOP;
--  het 1 dieu kien loc
--  xu ly xong 1 kenh
      commit;
  CLOSE caller_rs;
  END LOOP;

END;

/

