create PROCEDURE "PROC_SCAN_TO_OPEN" (num out number) AS
--- Author :duongtb
  lock_duration number := 48*60*60; 
  TYPE cursor_type IS REF CURSOR;
  rs_cur cursor_type;
  in_caller black_list.caller% TYPE;
  in_called black_list.line_id% TYPE;
  TYPE t_caller IS TABLE OF black_list.caller% TYPE;
  TYPE t_called IS TABLE OF black_list.line_id% TYPE;
  v_caller t_caller;
  v_called t_called;
   limit_rec number := 1000;
BEGIN
  num := 0;
  select param_value into lock_duration from param WHERE param_code='LOCK_DURATION';
-- chuyen sang s
  lock_duration := lock_duration*60;
   open
----      rs_cur for select caller, line_id from black_list where status = 1 and is_request_unlock = 1 and lock_level = 1 and (sysdate - insert_time)*24*60*60 >= lock_duration;
      rs_cur for select caller, line_id from black_list where status = 1 and lock_level = 1 and (sysdate - insert_time)*24*60*60 >= lock_duration;
--        LOOP
--              FETCH rs_cur INTO in_caller, in_called;
--                  EXIT WHEN rs_cur%NOTFOUND;
--                    update black_list set status = 0, last_unlock_time = sysdate, last_unlock_actor = 'System' , insert_time = sysdate where caller = in_caller and line_id = in_called;
--                    num := num + 1;
--        END LOOP;
        ----
         LOOP
            FETCH rs_cur bulk collect
              INTO v_caller, v_called limit limit_rec;
              EXIT WHEN v_caller.COUNT = 0;               
              FOR i IN v_caller.FIRST .. v_caller.LAST
                 LOOP
                      update black_list set status = 0, last_unlock_time = sysdate, last_unlock_actor = 'System' , insert_time = sysdate where caller = v_caller(i) and line_id = v_called(i);
                      num := num + 1;
                 end loop;
           EXIT WHEN rs_cur%NOTFOUND;
           END LOOP;
        ---
   close rs_cur;
 commit;
END PROC_SCAN_TO_OPEN;

/

