create PROCEDURE "PROC_WS_GETCALLBYCALLERAGENT" 
   ( rs in OUT RS_TYPES.RS_CURSOR,
  pagentid in varchar2,
  pcaller in varchar2,
  pstartTime in varchar2,
   pcallType in number)
   IS
--
-- To modify this template, edit file PROC.TXT in TEMPLATE
-- directory of SQL Navigator
--
-- Purpose: Briefly explain the functionality of the procedure
--
-- MODIFICATION HISTORY
-- Person      Date    Comments
-- ---------   ------  -------------------------------------------
   --variable_name                 datatype;
   -- Declare program variables as shown above
BEGIN
 if pcallType != -1 then
open rs for
    SELECT   a.agent_id agentId,
                      a.call_type callType,
                      a.caller customerPhoneNo,
                      to_char(a.call_start_time,'DD/MM/YYYY hh24:mi:ss') startTime,
                      to_char(a.call_end_time,'DD/MM/YYYY hh24:mi:ss') endTime,
                      a.duration callDuration,
                      url recordPath,
                      a.answer_time answerTime
               FROM   call a
              WHERE   a.agent_id = pagentId
                      AND a.caller = pcaller
                      AND a.start_time BETWEEN TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss') - 1/48
                                                AND  TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss') + 1/48

                          AND a.call_type = pcallType

            ORDER BY   start_time DESC;
else
open rs for
SELECT   a.agent_id agentId,
                      a.call_type callType,
                      a.caller customerPhoneNo,
                      to_char(a.call_start_time,'DD/MM/YYYY hh24:mi:ss') startTime,
                      to_char(a.call_end_time,'DD/MM/YYYY hh24:mi:ss') endTime,
                      a.duration callDuration,
                      url recordPath,
                      a.answer_time answerTime
               FROM   call a
              WHERE   a.agent_id = pagentId
                      AND a.caller = pcaller
                      AND a.start_time BETWEEN TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss') - 1/48
                                                AND  TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss') + 1/48



            ORDER BY   start_time DESC;
end if;
END; -- Procedure 

/

