create PROCEDURE "PROC_WS_GETCALLOUTBYLISTAGENT" 
     (  rs in OUT RS_TYPES.RS_CURSOR,
  pagentid in varchar2,
  pstartTime in varchar2,
  pendTime in varchar2,
  pminAnswerTime in number,
  pmaxAnswerTime in number,
   pmaxNumberCallPerAgent in number,
   prownum in number)
   IS
--
-- To modify this template, edit file PROC.TXT in TEMPLATE
-- directory of SQL Navigator
--
-- Purpose: Briefly explain the functionality of the procedure
--
-- MODIFICATION HISTORY
-- Person      Date    Comments
-- ---------   ------  -------------------------------------------
  -- variable_name                 datatype;
   -- Declare program variables as shown above
BEGIN
open rs for
   SELECT   *  FROM (
              SELECT   a.agent_id agentId,
                        a.call_type callType,
                        a.caller customerPhoneNo,
                        to_char(a.call_start_time,'DD/MM/YYYY hh24:mi:ss') startTime,
                        to_char(a.call_end_time,'DD/MM/YYYY hh24:mi:ss') endTime,
                        a.duration callDuration,
                        url recordPath,
                        a.answer_time answerTime
                        ,row_number() over (partition by agent_id order by dbms_random.value) rn
                 FROM   call a
                 WHERE --agent_id=pagentid
                    (agent_id in (select REGEXP_SUBSTR(pagentid,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(pagentid, '[^,]+', 1, level) is not null )) 
                        AND start_time BETWEEN TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss')
                                                  AND  TO_DATE (pendTime, 'DD/MM/YYYY hh24:mi:ss')
                        AND answer_time BETWEEN pminAnswerTime AND pmaxAnswerTime
                        AND call_type = 1
             --ORDER BY   dbms_random.value()
             ) --where rownum<=2;
             WHERE   rn <=pmaxNumberCallPerAgent and rownum <= prownum;
END; -- Procedure 

/

