create FUNCTION "STR2TBL" (p_string IN VARCHAR2, p_delimiter IN VARCHAR2)
    RETURN VARCHAR2
AS
    v_length   NUMBER := LENGTH(p_string);
    v_start    NUMBER := 1;
    v_index    NUMBER;
    v_result   VARCHAR2(200);
BEGIN
    WHILE(v_start <= v_length)
    LOOP
        v_index    := INSTR(p_string, p_delimiter, v_start);

        IF v_index = 0
        THEN
            v_result :=SUBSTR(p_string, v_start);
            v_start    := v_length + 1;
        ELSE
            v_result :=SUBSTR(p_string, v_start, v_index - v_start);
            v_start    := v_index + 1;
        END IF;
    END LOOP;

    RETURN v_result;
END;

/

