create PROCEDURE "TESTPROC_GETAGENTSTATUSDUR" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in DATE,
  toDate in DATE,
  agentIdIn in VARCHAR2,
  pstatus in NUMBER,
  listGroupId in VARCHAR2,
  pmax in NUMBER
) AS
BEGIN
  open rs for SELECT a.agent_id, SUM((CASE WHEN a.status = 0 THEN a.duration ELSE 0 END )) as logout,
    SUM((CASE WHEN a.status = 1 THEN a.duration ELSE 0 END )) as login,
    SUM((CASE WHEN a.status = 2 THEN a.duration ELSE 0 END )) as no_acd,
    SUM((CASE WHEN a.status = 3 THEN a.duration ELSE 0 END )) as acd,
--    SUM((CASE WHEN a.status = 3 THEN case when a.start_time < fromdate then round((a.stop_time - fromdate)*24*60*60) else case when a.stop_time > todate then round((toDate - a.start_time)*24*60*60) else a.duration end end  ELSE 0 END )) as acd,
    SUM((CASE WHEN a.status = 4 THEN a.duration ELSE 0 END )) as meeting,
    SUM((CASE WHEN a.status = 5 THEN a.duration ELSE 0 END )) as typing,
    SUM((CASE WHEN a.status = 6 THEN a.duration ELSE 0 END )) as at_lunch,
    SUM((case when a.STATUS = 7 then a.DURATION else 0 end )) as GO_OUT,
    SUM((case when a.STATUS = 16 then 60 else 0 end))  as NO_ANSWER,
    SUM((CASE WHEN a.status = 17 THEN a.duration ELSE 0 END )) as available_no_acd,
    SUM((case when a.STATUS = 10 then a.DURATION else 0 end )) as RINGING,
    SUM((case when a.STATUS = 11 then a.DURATION else 0 end )) as ANSWERING,
    SUM((case when a.STATUS = 12 then 60 else 0 end )) as dial_no_answer

    FROM agent a WHERE
    a.start_time between fromDate and toDate
    and (pstatus =-1 or a.status = pstatus)
    and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like ('%'|| agentIdIn ||'%'))
    and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
    GROUP BY a.agent_id ORDER BY acd desc;

END testPROC_GETAGENTSTATUSDUR;

/

