create PROCEDURE "TESTPROC_GETANSWERCALLDETAILS" (
 -- thong ke so cuoc tra loi cua Agent
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  TODATE in date,
  PAGENTID in VARCHAR2,
  limitTime in number,
  pcaller in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in NUMBER,
  pcallid in VARCHAR2,
  PDEVICEID in varchar2,
  listGroupId in VARCHAR2,
  pmax in NUMBER

) IS
  row_count number;
begin
  row_count := pmax;
  open rs for select agent_id, to_char(call_start_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(ring_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(connect_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(end_time,'yyyy-MM-dd hh24:mi:ss'),
    ROUND(ANSWER_TIME) as conference_time,
    URL,CALLER,b.line_name,CALL_ID,CALL_TYPE,DEVICE_ID, decode(CUSTOMER_TYPE,4,'KHNB','') KHNB
  from call a join line b on a.called = b.line_code
  where START_TIME between FROMDATE and TODATE
    and answer_time >= limittime and connect_time is not null
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller ||'%' escape '\')
    and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (PCALLTYPE = -1 or CALL_TYPE = PCALLTYPE)
    and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) like '%'||PAGENTID||'%' escape '\')
    and (PCALLID is null or PCALLID = '' or LOWER(CALL_ID) like '%'||PCALLID||'%' escape '\')
    and (PDEVICEID is null or PDEVICEID = '' or LOWER(DEVICE_ID) like '%'||PDEVICEID||'%' escape '\')
    and agent_id in (select user_name from vsa_users)
    --where group_id in (
    --  select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
    --  connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
    and rownum <= row_count
    order by start_time desc;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
end testproc_getAnswerCallDetails;

/

