create PROCEDURE "TESTPROC_GETCALLINTEST" -- vos_vietnb
-- thong ke cuoc goi call in
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  listQueue in VARCHAR2,       -- danh sach queue --> 4
  callerIn in VARCHAR2,           -- so dien thoai --> 5
  pjoinedIn in VARCHAR2,          -- dieu kien --> 6
  callIdIn in VARCHAR2,           -- ma cuoc goi --> 7
  agentIdIn in VARCHAR2,            -- ma nhan vien --> 8
  ptypeIn in number,              -- loai bao cao --> 9
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 10
) AS
--CURSOR uname_rs
--    IS
--  --  lay ra danh sach uname thuoc nhom nguoi dung quan ly
--    select user_name from users@tovsa where location_id in (
--      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
--      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null );
--  uname_rec uname_rs%rowtype;
--  listUname VARCHAR2(2000):= 'DEFAULT';
BEGIN
 -- lay ra danh sach uname dang string seperated comma
--  FOR uname_rec IN uname_rs
--  loop
--      listUname:=listUname || ',' || uname_rec.user_name;
--  end loop;
    if ptypeIn = 1 then
    -- chi tiet
        open rs for select a.call_id,
               a.caller,
               c.description,
               to_char  (a.start_time,'dd/MM/yyyy hh24:mi:ss'),
               a.waiting_time,
               to_char(a.first_ring_time,'dd/MM/yyyy hh24:mi:ss'),
               to_char(a.first_connect_time,'dd/MM/yyyy hh24:mi:ss'),
               a.agent_id,
               to_char(a.end_time,'dd/MM/yyyy hh24:mi:ss'),
               a.duration, b.description
        from CALLINFO a, end_code b, acd.queues c
        where a.START_TIME between FROMDATEIN and TODATEIN
        and a.in_reason = b.end_code_id
        and a.skill_id = c.queue_id
        and a.IS_TEST_CALL = 1
        and (listQueue is null or listQueue = '' or lower(a.SKILL_ID) in (
          select regexp_substr(listQueue,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(listQueue, '[^,]+', 1, level) is not null ))
        and (pjoinedIn = -1 or a.joined = pjoinedIn or (pjoinedIn > 0 and a.joined > 0))
        and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
        and (callerIn is null or callerIn = '' or lower(a.caller) like '%'||callerIn||'%' escape '\')
        and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%' escape '\')

        and rownum <= PMAXIN
        order by a.start_time desc;
  else
    -- tong hop
        open rs for select * from ( select * from
        (
            select a.caller as sdt, count(distinct a.call_id) as solangoi
            from callinfo a
            where start_time between fromDateIn and toDateIn
            and a.IS_TEST_CALL = 1
            and (listQueue is null or listQueue = '' or lower(a.SKILL_ID) in (
              select regexp_substr(listQueue,'[^,]+', 1, level) from dual
              connect by regexp_substr(listQueue, '[^,]+', 1, level) is not null ))
            and (pjoinedIn = -1 or joined = pjoinedIn or (pjoinedIn > 0 and joined > 0))
            and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
            and (callerIn is null or callerIn = '' or lower(a.caller) like '%'||callerIn||'%' escape '\')
            and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%' escape '\')
            group by caller
        )) where rownum <= pmaxIn;
    end if;

END TESTPROC_GETCALLINTEST;

/

