create PROCEDURE "TESTPROC_GETDETAILCALLAGENT" 
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDate in Date,             -- thoi gian bat dau thong ke --> 2
  TODATE in date,               -- thoi gian ket thuc thong ke --> 3
  AGENTID in varchar2,             -- id nguoi nhan cuoc goi --> 4
  LISTLINE in varchar2,
  LIMITTIME in number,
  listGROUPID in varchar2,
  PCALLTYPE in number,  
  PMAX in number                -- so luong ban ghi toi da duoc export --> 14
) as
begin
    open rs for select a.call_id, 
--                       b.acc_code,          -- ma tai khoan
                       a.caller,            -- so dien thoai
                       a.called,            -- kenh
                       a.call_start_time,   -- thoi gian bat dau cuoc goi
                       a.ring_time,         -- thoi gian do chuong
                       a.connect_time,      -- thoi diem nhac may
                       a.agent_id,          -- ma agent
                       a.end_time,          -- thoi diem ket thuc
                       a.ANSWER_TIME        -- thoi luong dam thoai cua agent voi kh
                from call a
--                , call_acc b 
                where a.start_time between fromDate and toDate
                and AGENT_ID = AGENTID
--                and a.CALL_ID = B.CALL_ID
                and (LISTLINE is null or LISTLINE = '' or CALLED in (
                select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
                connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null )) 
               
                  and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
                and (PCALLTYPE is null or PCALLTYPE = -1 or a.CALL_TYPE = PCALLTYPE)
                and ANSWER_TIME>=LIMITTIME
                and rownum <= pmax;
END testPROC_GETDETAILCALLAGENT;
---------

/

