create PROCEDURE "TESTPROC_GETVIP" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in VARCHAR2,
  toDate in VARCHAR2, 
  VIPID in VARCHAR2,
  RANKID in NUMBER,
  pstatus in number,  
  pmax in number
) AS
ifrom date := sysdate;
ito date := sysdate;
BEGIN
if fromDate is not null 
then
  ifrom := to_date(fromDate, 'dd/MM/yyyy hh24:mi:ss');  
  ito := to_date(toDate, 'dd/MM/yyyy hh24:mi:ss');
end if;
if toDate is not null 
then
  ito := to_date(toDate, 'dd/MM/yyyy hh24:mi:ss');
end if;
open rs for select v.vip_id,v.status,v.sms_status,v.actor,
to_char(v.insert_time ,'dd/MM/yyyy hh24:mi:ss'),
r.rank_name,v.rank_id,v.id,v.line 
from vip v left outer join rank r on v.rank_id = r.rank_id
where (fromDate is null or fromDate = '' or v.insert_time >= ifrom)
and (toDate is null or toDate = '' or v.insert_time <= ito)
  
  and (vipid is null or vipid = '' or v.vip_id like '%' || vipid ||'%')
  and (rankid is null or rankid = -1 or v.rank_id = rankid)
  and (pstatus is null or pstatus = -1 or v.status = pstatus)
  and rownum <= 500
  ; 
END TESTPROC_GETVIP;

/

