create PROCEDURE "TEST_GETIVRDETAIL" (
 -- THONG KE CHI TIET CUOC GOI KENH IVR
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  pcaller in number,
  pmax in number
) AS
BEGIN
  
    open rs for select called,caller,to_char(start_time,'dd/MM/yyyy hh24:mi:ss') as startTime,  
    to_char(end_time,'dd/MM/yyyy hh24:mi:ss') as stopTime,
    duration as seconds,  
    round(duration/60 + 0.499) as minutes, dtmf  
    from callinfo 
    where start_time between fromDate and toDate
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')
    and rownum <= pmax;
END test_GETIVRDETAIL;
-------------

/

