create trigger BLACK_LIST_LOG_INSERT_BK
  after insert or update of LOCK_LEVEL, IS_REQUEST_UNLOCK
  on BLACK_LIST
  for each row
  DECLARE
  duplicate_info EXCEPTION;
  num_row number;
  PRAGMA EXCEPTION_INIT (duplicate_info, -00001);
BEGIN
if (:new.lock_level = 1 or :new.lock_level = 2) and :new.status = 1 then
--cap nhat vao bang black_list_log
Insert into BLACK_LIST_LOG (black_list_log_id,status,sms_status,redirect_type,last_lock_actor,
last_lock_time,last_unlock_actor,last_unlock_time,total_call,line_id,description,insert_time,lock_level,
lock_sum,is_sent,is_request_unlock,rule_exception_id,caller,sms_sent_time,sms_sent_actor, black_list_id) 

values (black_list_log_seq.nextval,:new.status,:new.sms_status,:new.redirect_type,
:new.last_lock_actor,:new.last_lock_time,:new.last_unlock_actor,:new.last_unlock_time,
:new.total_call,:new.line_id,:new.description,:new.insert_time,:new.lock_level,
:new.lock_sum,:new.is_sent,:new.is_request_unlock,:new.rule_exception_id,
:new.caller,:new.sms_sent_time,:new.sms_sent_actor,:new.black_list_id);

end if;
if :new.lock_level = 0 or :new.status = 0 then
  select count(*) into num_row from black_list_log where black_list_id = :new.black_list_id;
  if num_row > 0 then
  update black_list_log set status=:new.status,sms_status = :new.sms_status,redirect_type=:new.redirect_type,
last_lock_actor=:new.last_lock_actor,last_lock_time=:new.last_lock_time,last_unlock_actor=:new.last_unlock_actor,last_unlock_time=:new.last_unlock_time,
total_call=:new.total_call,line_id=:new.line_id,description=:new.description,lock_level=:new.lock_level,
lock_sum=:new.lock_sum,is_sent=:new.is_sent,is_request_unlock=:new.is_request_unlock,rule_exception_id=:new.rule_exception_id,
caller=:new.caller,sms_sent_time=:new.sms_sent_time,sms_sent_actor=:new.sms_sent_actor where black_list_id = :new.black_list_id;
  end if;
end if;

if ((:new.lock_level  in (1,2) and :new.is_actual_change = 1) or :new.is_request_unlock = 1) then
--if (:new.lock_level  in (1,2) and :new.is_actual_change = 1) then
  --cap nhat bang black_list_day_sum
  select count(*) into num_row from black_list_day_sum where to_char(day_start,'dd-MM-yyyy') = to_char(:new.insert_time, 'dd-MM-yyyy') and line_id=:new.line_id;
  if num_row > 0 then 
  
      if :new.lock_sum = 1 then
          if :new.is_request_unlock = 1 then
             update black_list_day_sum set request_unlock_sum = request_unlock_sum + 1
             where to_char(day_start,'dd-MM-yyyy') = to_char(:new.insert_time, 'dd-MM-yyyy') and line_id=:new.line_id;
          else 
             update black_list_day_sum set first_lock_sum = first_lock_sum + 1
             where to_char(day_start,'dd-MM-yyyy') = to_char(:new.insert_time, 'dd-MM-yyyy') and line_id=:new.line_id;
          end if;
      else 
          if :new.is_request_unlock = 1 then
              update black_list_day_sum set request_unlock_sum = request_unlock_sum + 1 
              where to_char(day_start,'dd-MM-yyyy') = to_char(:new.insert_time, 'dd-MM-yyyy') and line_id=:new.line_id; 
          else 
             update black_list_day_sum set second_lock_sum = second_lock_sum + 1
             where to_char(day_start,'dd-MM-yyyy') = to_char(:new.insert_time, 'dd-MM-yyyy') and line_id=:new.line_id;
          end if;
      end if;    
   else 
       Insert into black_list_day_sum (black_list_day_sum_id,day_start,first_lock_sum,
       second_lock_sum,request_unlock_sum,line_id) 
       values (black_list_day_sum_seq.nextval, to_date(to_char(:new.insert_time, 'dd-MM-yyyy'),'dd-MM-yyyy'),1,0,0,:new.line_id);
   end if;
 end if;
END black_list_log_insert_bk;

/

